function ActivityTab(config, api)
{
  this.config;
  this.api = api;
  if(config == null) this.config = new AppConfig();
  else this.config = config;


  //***************************************************************************
  // The onchange handler for dropdown boxes used to filter out tasks in the
  // Activity tab
  //***************************************************************************
  this.changeFilter = function(param, filter)
  {
    // 1. Update app configuration
    this.config.setParameter(param, $F(filter));
    this.config.commit();
    if(filter == 'wsFltr')
    {
      this.populatePageDropdown($F(filter));
    }
    // 2. Populate acitivities
    this.populateActivities(config.getIntParameter('wsSelection')); //Workspace ID
  }

  //***************************************************************************
  // The function populates Page dropdown in the Activity tab.
  //***************************************************************************
  this.populatePageDropdown = function(ws)
  {
    var ops = '<option id="pgFltrOp0" value="0" >All</option>';
    if(ws != 0)
    {
      var tmpJSON = api.callMethod('wizehive.pages.getList',{'format':'json','token':api.token,'per_page':1000});
      var tmpCats = tmpJSON.evalJSON(true);
      var cats = tmpCats.pages;
      if(cats)
      {
        var selected = this.config.getIntParameter('pageSelection');
        cats.each(function (el) { 
            if(el['workspace_id'] == ws) 
            {
              if(selected == el['id'])
              {
                ops += '<option id="pgFltrOp'+el['id']+'" value="'+el['id']+'" selected >'+el['name']+'</option>'; 
              }
              else
              {
                ops += '<option id="pgFltrOp'+el['id']+'" value="'+el['id']+'">'+el['name']+'</option>'; 
              }
            }
          });
      }
    }
    else
    {
      // Reset page selection to 0
      this.config.setParameter('pageSelection', '0');
    }
    $('pgFltr').update(ops);
    Event.stopObserving('pgFltr', 'change');
    Event.observe('pgFltr', 'change', function(){activityTab.changeFilter('pageSelection', 'pgFltr');});
  }

  
  //***************************************************************************
  // The function populates activities table in the Activity tab.
  //***************************************************************************
  this.populateActivities = function(ws)
  {
    // 1. Remove all activities
    var activitiesDiv = $('activitiesDiv');
    activitiesDiv.innerHTML = '';
    // 2. Prepare options for JSON to apply filters
    // Load configuration parameters
    var displayPics = this.config.getBoolParameter('displayPicturesStng');
    var charactersToShow = this.config.getIntParameter('showNotesCharactersStng');
    charactersToShow = (charactersToShow > 0)?charactersToShow:240;
    var postType, replyType, postByEmailType, taskType;
    postType = this.config.getBoolParameter('noteTypePostStng');
    replyType = this.config.getBoolParameter('noteTypeReplyStng');
    postByEmailType = this.config.getBoolParameter('noteTypePostByEmailStng');
    taskType = this.config.getBoolParameter('noteTypeTaskStng');
    if(!(postType || replyType || postByEmailType || taskType))
    {
      alert('Not a single note type has been specified in settings. Please provide at least one type');
      return;
    }
    var contentClass;
    ws = this.config.getIntParameter('wsSelection');
    if(ws==0) 
      var options = {'format':'json','token':api.token};
    else
      var options = {'format':'json','token':api.token, 'ws_id': ws};
    if(this.config.getIntParameter('pageSelection') > 0) 
    {
      options.pg_id = this.config.getIntParameter('pageSelection');
    }
    var tmpJSON = api.callMethod('wizehive.notes.getList',options);
    //air.trace(tmpJSON);
    var tmpNotes = tmpJSON.evalJSON(true);
    var notes = tmpNotes.notes;
    var type;
    var div, row, cell;
    notes.each(function (activity) {
      type = activity.Post.type;
      // Check if a note should be displayed based on its type and user's settings
      if(!(type == 3 && replyType) && // no replies
         !(taskType) && // no tasks
         !(type == 1 && postByEmailType) && // no notes by email
         !(type == 0 && postType)) // no entered notes 
        return;
      //air.trace('Task type:' + activity.Post.type);
      var cl = (activity.Post.type==3)?'reply':(activity.Post.type==2)?'task':'post';
      var div = new Element("div",{'class':cl,id:'post' + activity.Post.id});
      if(displayPics)
      {
        var imgLoc = activity.User.image?(activity.User.image.match('.'))?'http://s3.amazonaws.com/wizehive-imgs/small-'+activity.User.image:'images/50.png':'images/50.png';
        var e2 = new Element("span",{'class':'pimg'}).update('<img src="'+imgLoc+'">');
        div.appendChild(e2);
        contentClass = 'pcontent';
      }
      else
       contentClass = 'pcontentNoImg';
      var e3 = new Element("div",{'class':contentClass,'title':activity.Post.body});
      var bod = (activity.Post.body.length>charactersToShow)?(activity.Post.body.substr(0, charactersToShow)+'<a href="#" id="viewp'+activity.Post.id+'">...</a>'):activity.Post.body;
      var gName = activity.Workspace.name?activity.Workspace.name:'Uncategorized';
      var cName = activity.Page.name?activity.Page.name:'';
      var e4 = new Element("span",{id:'edit'+activity.Post.id}).update(cName+'('+gName+'):'+bod+'<br />');
      var puser = new Element("span",{'class':'post-user'}).update('a '+cl+' by '+activity.User.username);
      var replyLink = new Element("a",{'href':'#',id:'reply'+activity.Post.id}).update('reply');
      var linkid = 't'+activity.Post.task_node_id;
      if ((linkid=='tnull') || (linkid=='t0')) linkid = activity.Post.parent_id;
      if ((linkid=='null') || (linkid==0)) linkid = activity.Post.id;
      var link = server+'/comments/view/'+linkid+"/"+activity.Post.id+"/3";
      var pdate = new Element("span",{'class':'post-date'}).update(' on '+activity.Post.dispDate+' <a href="'+link+'" target="_blank">view</a> ');
      pdate.appendChild(replyLink);
      e3.appendChild(e4);
      e3.appendChild(puser);
      e3.appendChild(pdate);
      div.appendChild(e3);
      activitiesDiv.appendChild(div);
      Event.stopObserving('reply'+activity.Post.id);
      Event.observe('reply'+activity.Post.id, 'click', activityTab.onNoteReplyLink.bindAsEventListener(this, activity.Post.id) );
      if($('viewp'+activity.Post.id)) 
      {
        Event.stopObserving('viewp' + activity.Post.id);
        Event.observe('viewp'+activity.Post.id, 'click', loadTip.bindAsEventListener(this, activity.Post.body)  );
      }
    });

  }

  //***************************************************************************
  // The following methods are primarily used as event handlers for various 
  // controls/elements in the Tasks tab
  //***************************************************************************

  //***************************************************************************
  // The function is an onclick handler for reply link that is shown below every
  // note and it opens a new window where a user can enter a reply and save it
  // by clicking Save link which is handled by saveModalAction function 
  //***************************************************************************
  this.onNoteReplyLink = function(event, noteId)
  {
    modalWinObject.type = 'note';
    modalWinObject.Id = noteId;
    modalWinObject.operation = 'reply';
    modalWinObject.content = '';
    openModalWindow();
  }
}