//server = 'http://dev.wizehive.com';
server = 'https://www.wizehive.com';
var api = new WizeHiveAPI(jsGet('k'), jsGet('s'));
var config = new AppConfig();
var frob;
var ws = 0; //workspace they are viewing
var wbs;  //user's workspaces
var myTimer;
var currentTab = 'note'; // holds a name of the current tab note/task
var modalWin = null; //reply window
var modalWinObject = {type:'', Id:'', content:'', operation:''}; // used in modal window for reply/edit operations for notes/tasks
var stngWnd = null; // Settings window
//custom chrome 
var max = false;
var min = false;
var taskTab = new TaskTab(config, api);
var activityTab = new ActivityTab(config, api);

// Check if there are any configuration parameters. If not, set default values for some of them.
if(!config.getBoolParameter('ParametersDefined'))
{
  // 1. Tasks Default Settings
  // Second Line Options
  config.setParameter('showSecondLineStngYes', true);
  config.setParameter('showSecondLineStngNo', false);
  config.setParameter('showScndLinePersonStng', true);
  config.setParameter('showScndLineWsStng', true);
  config.setParameter('showScndLineDueDateStng', true);
  config.setParameter('showScndLinePageStng', true);
  config.setParameter('showScndLineStatusStng', true);
  config.setParameter('showScndLineCategoryStng', true);
  config.setParameter('showScndLinePriorityStng', true);
  config.setParameter('showTaskCharactersStng', 240);
  // Whose Tasks
  config.setParameter('whoseTasksMyStng', false);
  config.setParameter('whoseTasksEveryoneStng', true);
  // Status Options
  config.setParameter('statusOpenStng', true);
  config.setParameter('statusInProgressStng', true);
  config.setParameter('statusCompletedStng', true);
  config.setParameter('statusArchivedStng', false);
      
  // 2. Activity Default Settings
  config.setParameter('displayPicturesStng', true);
  config.setParameter('showNotesCharactersStng', 240);
  config.setParameter('noteTypePostStng', true);
  config.setParameter('noteTypeTaskStng', true);
  config.setParameter('noteTypePostByEmailStng', true);
  config.setParameter('noteTypeReplyStng', true);

  // 3. Other Default Settings
  config.setParameter('updateIntervalStng', 180);
  config.setParameter('showNewUpdateAlertStng', true);
  config.setParameter('displayAlertIntervalStng', 60);
  config.setParameter('sendWindowToTrayStng', false);
  config.setParameter('alwaysShowTrayIconStng', false);
  config.setParameter('launchOnStartupStng', true);
  // Set to launch on start up
  try
  { 
    air.NativeApplication.nativeApplication.startAtLogin = true; 
  } 
  catch(e) 
  { 
    //alert('Cannot change Launch on startup option (' + $('launchOnStartupStng').checked + '): ' + e.message); 
  }

  // 4. Miscellaneous Settings
  config.setParameter('groupSelection', 'Priority');
  config.setParameter('initialSettingsTab', 'tasksTab');
  config.setParameter('ParametersDefined', 'true');
  config.commit();
}
//try to load token (if they've used the app before)
api.token = config.getStringParameter('TOKEN');

//air.trace('token='+api.token);

if(api.token) 
{
  //this is so doLoad is not run in Parsing Time
  setTimeout(doLoad, 1);
}
else 
{
  Event.observe(window, 'load', doLoad);
}

function doLoad() 
{
  doLoadStyle();
  
  // Restore main window position
  var xx = 100;
  var yy = 100;
  var wwidth = 430;
  var hheight = 650;

  var param;
  param = config.getIntParameter('xx');
  if(param > 0) xx = param;
  param = config.getIntParameter('yy');
  if(param > 0) yy = param;
  param = config.getIntParameter('hheight');
  if(param > 0) hheight = param;
  param = config.getIntParameter('wwidth');
  if(param > 0) wwidth = param;
  
  //set x, y 
  window.nativeWindow.x = xx;
  window.nativeWindow.y = yy;
  window.nativeWindow.width = wwidth;
  window.nativeWindow.height = hheight;
  window.nativeWindow.addEventListener(air.NativeWindowBoundsEvent.RESIZE, resize);
  
  try {
    
    if(api.token) 
    {
      //air.trace('found api.token');
      $('content_container').hide();
      $('content_container2').show();
      //get the workspace/page js only first time for the drop down selects
      getStuff();
      
  
    } 
    else 
    {
      Event.observe('authorize', 'click', authorize );
      $('content_container').show();  
    }
  } catch(e) {
  }
}

//***************************************************************************
//  authorize when run for the first time
//***************************************************************************
function authorize() 
{
  var tmpJSON = api.callMethod('wizehive.auth.getFrob',{'format':'json'})
  var tmpAr = tmpJSON.evalJSON(true);
  frob = tmpAr.frob;
  if (tmpAr.frob) 
  {
    var url = api.getLoginURL('delete',tmpAr.frob);
    air.navigateToURL(new air.URLRequest(url));
    
    $('h1message').update('Opening window')
    $('auth_message').update('Please check your browser for instructions.<br />The window may open behind another window.');
    $('authorize').hide();
    tTimer = new air.Timer(4000, 0); //4000 = 4 seconds
    tTimer.repeatCount = 0;
    tTimer.addEventListener(air.TimerEvent.TIMER, function(){
       tTimer.stop();
       $('h1message').update('Ready?')
       $('auth_message').update('Once you\'ve authorized this application, click on the button below to start using WizeHive.');
       $('authorize').show();
       $('authorize').value = 'Start Application';
       Event.stopObserving('authorize', 'click', authorize);
       Event.observe('authorize', 'click', getToken);
    });
    tTimer.start();
  }
}

function getToken() 
{
  var tmpJSON2 = api.callMethod('wizehive.auth.getToken',{'format':'json','frob':frob})
  //air.trace(tmpJSON2);
  var tmpAr2 = tmpJSON2.evalJSON(true);
  api.token = tmpAr2.rsp.auth.token;
  config.setParameter('TOKEN', api.token);
  config.commit();
  getStuff();
}

//***************************************************************************
// The function is called from getActivity() and starts a timer that forces
// the main window to reload activities/tasks every N seconds specified 
// in the tab Other (parameter 'Update every seconds' of the Settings window
//***************************************************************************
function startTimer() 
{
  if (myTimer && myTimer.running) myTimer.stop();
  var interval = config.getIntParameter('updateIntervalStng');
  if(interval > 0)
  {
    myTimer = new air.Timer(interval * 1000, 0); //interval * 1000 = interval seconds
    myTimer.repeatCount = 0;
    myTimer.addEventListener(air.TimerEvent.TIMER, function(){getActivity(1);});
    myTimer.start();
  }
} 

//***************************************************************************
// The function is called from window.onload event to load the content (excluding
// the content of Activity/Tasks tabs) of the main window of the app.
//***************************************************************************
function getStuff() 
{ 
  
  var tmpJSON = api.callMethod('wizehive.workspaces.getList',{'format':'json','token':api.token});

  var tmpWbs = tmpJSON.evalJSON(true);
  if (tmpWbs.rsp && (tmpWbs.rsp.stat=='fail')) 
  {
    //something went wrong, let's make them start over
    //air.EncryptedLocalStore.reset();
    Event.observe('authorize', 'click', authorize );
    $('content_container').show(); 
    $('content_container2').hide(); 
  } 
  else 
  {
    $('account_login').addClassName('bordr');
    $('account_login').addClassName('smaller');
    $('account_login').update('');//data); 

    //air.trace('now getting recent activity');
    getActivity(1);
  }
}

function getActivity(flag) 
{
  if(ws==0) 
    var options = {'format':'json','token':api.token};
  else
    var options = {'format':'json','token':api.token, 'ws_id': ws};
  
  $('account_login').update(''); 
  $('account_bar').show(); // Show Activity/Tasks tabs
  if(currentTab=='task') 
  {
    loadTab("tasks.html", $('account_login'), 'tasks');
  } 
  else 
  {
    loadTab("activity.html", $('account_login'), 'activity');
  }
  if (flag) startTimer(); //run this every 180 seconds
}


//***************************************************************************
// Method to load a tab into a given container using AJAX
//***************************************************************************
function loadTab(pageurl, container, tabId)
{
  var page_request = false;
  if(window.ActiveXObject)
  { //Test for support for ActiveXObject in IE first (as XMLHttpRequest in IE7 is broken)
    try 
    {
      page_request = new ActiveXObject("Msxml2.XMLHTTP");
    } 
    catch (e)
    {
      try
      {
        page_request = new ActiveXObject("Microsoft.XMLHTTP");
      }
      catch (e){}
    }
  }
  else if (window.XMLHttpRequest) // if Mozilla, Safari etc
    page_request = new XMLHttpRequest();
  else
    return false;
  var ajaxfriendlyurl=pageurl.replace(/^http:\/\/[^\/]+\//i, "http://"+window.location.hostname+"/") ;
  if(tabId == 'tasks')
    page_request.onreadystatechange=function(){onTaskTabReadyStateChange(page_request, pageurl, container);};
  else 
    page_request.onreadystatechange=function(){onActivityTabReadyStateChange(page_request, pageurl, container);};
  page_request.open('GET', ajaxfriendlyurl, true);
  page_request.send(null);
}

//***************************************************************************
// When the task tab is loaded using the method loadTab
// the page's state event is processed by onActivityTabReadyStateChange() to insert 
// html content of the page into the provided container as soon as the page is loaded
//***************************************************************************
function onActivityTabReadyStateChange(page_request, pageurl, container)
{
  var divId=container.id;
  document.getElementById(divId).innerHTML="<img src='images/loading.gif' /> Requesting content...";//Display "fetching page message"
  if(page_request.readyState == 4 && 
     (page_request.status==200 || window.location.href.indexOf("http")==-1))
  {
    document.getElementById(divId).innerHTML=page_request.responseText;
    // 1.1 Populate Workspace and Page dropdowns
    populateWorkspaceAndPageDropdowns(activityTab);
    // 1.3 Attach onclick event handler to the Save link
    Event.observe('saveActivityButton', 'click', function(){savePost();});
    Event.observe('pbta', 'focus', function(){$('pbta').style.color='#000';$('pbta').value='';});
    //save note on <ENTER>
      Event.observe('pbta', 'keypress', function(event) {
        if (event.keyCode == Event.KEY_RETURN && !event.altKey && !event.shiftKey) {
          savePost();
          Event.stop(event);
        }
      });
    // 2. Populate Activities Table
    activityTab.populateActivities(ws);
  }
}

//***************************************************************************
// The method is invoked when either tab is loaded
//***************************************************************************
function populateWorkspaceAndPageDropdowns(tab)
{
  // 1. Populate filter/group dropdowns and set them based on app configuration
  // 1.1 Populate Workspace Dropdown
  var tmpJSON = api.callMethod('wizehive.workspaces.getList',{'format':'json','token':api.token});
  var tmpWbs = tmpJSON.evalJSON(true);
  wbs = tmpWbs.workspaces;
  wbs.sort(grpSort);
  var selected = config.getIntParameter('wsSelection');
  var ops = '<option id="wsFltrOp0" value="0" >All workspaces</option>';
  wbs.each(function (el) {
      // 1.1.1 Set selected value from application configuration
      if(selected == el['id'])
      {
        ops += '<option id="wsFltrOp'+el['id']+'" value="'+el['id']+'" selected >'+el['name']+'</option>';
      }
      else
      {
        ops += '<option id="wsFltrOp'+el['id']+'" value="'+el['id']+'" >'+el['name']+'</option>';
      }
    });
  $('wsFltr').update(ops);
  // 1.1.2 Assign onchange handler only after setting the selected value above to avoid
  // multiple unnecessary calls of populateTasks() function from event handlers
  Event.stopObserving('wsFltr', 'change');
  Event.observe('wsFltr', 'change', function(){tab.changeFilter('wsSelection', 'wsFltr');});

  // 1.2 Populate Page Dropdown
  tab.populatePageDropdown(selected);
  
  //resize input box, if needed
  resize();
}

//***************************************************************************
//  Is called from populateWorkspaceAndPageDropdowns() to sort workspaces received from the server 
//***************************************************************************
function grpSort(a,b) 
{
  return (a.name>b.name);
}


//***************************************************************************
// When the task tab is loaded using the method loadTab
// the page's state event is processed by onTaskTabReadyStateChange() to insert 
// html content of the page into the provided container as soon as the page is loaded
//***************************************************************************
function onTaskTabReadyStateChange(page_request, pageurl, container)
{
  var divId=container.id;
  document.getElementById(divId).innerHTML="<img src='images/loading.gif' /> Requesting content...";//Display "fetching page message"
  if(page_request.readyState == 4 && 
     (page_request.status==200 || window.location.href.indexOf("http")==-1))
  {
    document.getElementById(divId).innerHTML=page_request.responseText;
    // Because of AIR security constraints imposed on javascript in dynamically
    // loaded pages we have to populate Task tab here
    // As javascript is not executed when a page is loadded through ajax in adobe sandbox
    // event handlers have to be attached here as well
    // 1. Populate filter/group dropdowns and set them based on app configuration
    // 1.1, 1.2 Populate Workspace Dropdown
    populateWorkspaceAndPageDropdowns(taskTab);
    // 1.3 Populate Group by dropdown
    // 1.3.1 Set selected value from application configuration
    var selected = config.getStringParameter('groupSelection').length > 0 ? config.getStringParameter('groupSelection') : 'Person';
    for(var i=0; i < $('grpTskFltr').length; i++)
      if($('grpTskFltr')[i].value == selected) { $('grpTskFltr').selectedIndex = i; break; }

    // 1.3.2 Assign onchange handler
    Event.observe('grpTskFltr', 'change', function(){taskTab.changeFilter('groupSelection', 'grpTskFltr');});
    
    // 1.4 Populate Who's dropdown
    // 1.4.1 Set selected value from application configuration
    if(config.getBoolParameter('whoseTasksEveryoneStng'))
      $('whoTskFltr').selectedIndex = 0;
    else
      $('whoTskFltr').selectedIndex = 1;

    // 1.4.2 Attach onchange event handler
    Event.observe('whoTskFltr', 'change', function(){taskTab.changeFilter('', 'whoTskFltr');});

  //moved 1.5 and 1.7 to settings
    // 1.5 Populate Priority dropdown
    // 1.5.1 Set selected value from application configuration
    //selected = config.getIntParameter('prioritySelection');
    //for(var i=0; i < $('prtyTskFltr').length; i++)
    //  if($('prtyTskFltr')[i].value == selected) { $('prtyTskFltr').selectedIndex = i; break; }

    // 1.5.2 Attach onchange event handler
    //Event.observe('prtyTskFltr', 'change', function(){taskTab.changeFilter('prioritySelection', 'prtyTskFltr');});

    // 1.6.1 Attach onclick event handler to the More Filters link
    Event.observe('moreFiltersLink', 'click', function(){openSettings('tasksTab');});
    
    // 1.7 Populate Category dropdown
    taskTab.populateLists(api.token);
    
    // 1.8 Attach onclick event handler to the Save link
    Event.observe('saveTaskButton', 'click', function(){savePost();});
    Event.observe('pbta', 'focus', function(){$('pbta').style.color='#000';$('pbta').value='';});
    //save note on <ENTER>
      Event.observe('pbta', 'keypress', function(event) {
        if (event.keyCode == Event.KEY_RETURN && !event.altKey && !event.shiftKey) {
          savePost();
          Event.stop(event);
        }
      });
      
    // 2. Populate Task Table
    taskTab.populateTasks();
  }
}


function loadTip(evt,bod) 
{
  Tip('<div style="width:300px">'+bod+'</div>');
}

//***************************************************************************
// The function is called every time a user clicks on Save link. Entered note/task
// is sent over to the server
//***************************************************************************
function savePost() 
{
  var tmp;
  if (currentTab =='task') 
    tmp = api.callMethod('wizehive.tasks.add',{'ws_id': $F('wsFltr'),'pg_id': $F('pgFltr'),'task': $('pbta').value,'token':api.token},'POST');
  else 
    tmp = api.callMethod('wizehive.notes.add',{'ws_id': $F('wsFltr'),'pg_id': $F('pgFltr'),'text': $('pbta').value,'token':api.token},'POST');
  //air.trace(tmp);
  if(tmp.match('rsp stat="ok"')) 
  {
    $('pbta').value = '';
    showStatus('Your ' + currentTab + ' has been saved');
  } 
  else 
  {
    alert("Error saving " + currentTab + "."); 
  } 
   
  getActivity();
}

//***************************************************************************
// The function opens up a new window where a user can edit/create a note/task
// After a user clicks Save link the result is handled by saveModalAction function 
//***************************************************************************
function openModalWindow() 
{
  var options = new air.NativeWindowInitOptions();
  var width = 450;
  var height = 250;
  
  var bounds = new air.Rectangle(window.nativeWindow.x-20, window.nativeWindow.y+100, width, height);
    
  options.systemChrome = air.NativeWindowSystemChrome.NONE;
  options.type = air.NativeWindowType.LIGHTWEIGHT;
  

  var xx=window.nativeWindow.x-20;
  var yy=window.nativeWindow.y+100;
  modalWin = window.open( 'modalWin.html', 'modalWin', 'width = 450, height = 250,left='+xx+',top='+yy );
  //air.trace('moved to '+xx+','+yy+'?');

}

//***************************************************************************
// The function is called from modalWin.html (which is opened by
// openModalWindow() function. It saves an action (for note/task)
//***************************************************************************
function saveModalAction(evt, rid2, rtext, ops) 
{
  //air.trace('rid='+rid2+' rtext='+rtext);
  var options = {};
  var methodName;
  var methodType;

  if(modalWinObject.type == 'note')
  {
    methodName = 'wizehive.notes.reply';
    options = {'id': rid2, 'text': rtext, 'token':api.token};
    methodType = 'POST';
  }
  else if(modalWinObject.type == 'task')
  {
    if(modalWinObject.operation == 'reply')
    {
      methodName = 'wizehive.tasks.reply';
      options = {'id': rid2, 'text': rtext, 'token':api.token};
      methodType = 'POST';
    }
    else if(modalWinObject.operation == 'edit')
    {
      methodName = 'wizehive.tasks.edit';
      options = ops;
      methodType = 'POST';
    }
    //TBD
  }
  modalWin.close();
  // Call API
  var tmp='';
  try
  {
    tmp = api.callMethod(methodName, options, methodType);
  }
  catch(e)
  {
    //alert(e);
  }
  //air.trace(tmp);
  if(tmp.match('rsp stat="ok"')) 
  {
     showStatus('Your ' + modalWinObject.type + ' ' + modalWinObject.operation + ' has been saved.');
  } 
  else 
  {
     alert("Error saving " + modalWinObject.type + " " + modalWinObject.operation + "."); 
  } 
   
  getActivity();
  
}

//***************************************************************************
// Method to open Settings window. Gets called when a user clicks Settings linke in the title bar
//*************************************************************************** 
function openSettings(startTab)
{
  startTab = (currentTab=='note')?'activityTab':'tasksTab';
  if(stngWnd == null)
  {
    // Will use the local store to pass in the inital tab
    config.setParameter('initialSettingsTab', startTab);
    config.commit();
    var options = new air.NativeWindowInitOptions(); 
    options.systemChrome = "none"; 
    options.type = "lightweight"; 
 
    var windowBounds = new air.Rectangle(window.nativeWindow.bounds.left + window.nativeWindow.bounds.width/10, 
                                         window.nativeWindow.bounds.top + window.nativeWindow.bounds.height/10, 380, 510); 
    stngWnd = air.HTMLLoader.createRootWindow(true, options, true, windowBounds); 
    // Create 'opener' property to store reference to the main window
    stngWnd.window.opener = window;
    stngWnd.load(new air.URLRequest("settings.html"));
  }
  else
  {
    stngWnd.window.focus();
    stngWnd.window.document.getElementById(startTab).onclick();
  }
}

//***************************************************************************
// Onclick event handler for Activity/Tasks tabs. Changes opacity of a tab a user clicked on
// and loads data (notes or tasks). 
//***************************************************************************
function changeView(tabId) 
{
  currentTab = tabId;
  var other = (tabId=='note')?'task':'note';
  // Change opacity of a tab that is clicked to 1
  $('v' + tabId + 's').style.opacity = 1;
  // Change opacity of another tab to .55;
  $('v' + other + 's').style.opacity = 0.55;
  
  getActivity();
}

//***************************************************************************
// The function displays a passed in message in a status bar (id statusBar)
// for a period of time specified in timePeriod in seconds. If time period is not specified
// the message is displayed for 3 seconds.
//***************************************************************************
function showStatus(message, timePeriod)
{
  $('statusBar').style.left = window.nativeWindow.bounds.width/3;
  $('statusBar').show();
  $('statusBar').update("<img src='images/loading.gif' />" + message);
  if(!timePeriod) setTimeout(hideStatusBar, 3000);
  else setTimeout(hideStatusBar, timePeriod * 1000);
}

//***************************************************************************
// The function hides the status bar and clears its message.
//***************************************************************************
function hideStatusBar() 
{
  $('statusBar').update('');
  $('statusBar').hide();
}

//read the x and y before the window is closed and save them to db
function onWindowClose() 
{
    config.setParameter('xx', window.nativeWindow.x);
    config.setParameter('yy', window.nativeWindow.y);
    config.setParameter('wwidth', window.nativeWindow.width);
    config.setParameter('hheight', window.nativeWindow.height);
    config.commit();     
}

// Move window by grabbing bar
function doBar()
{
  window.nativeWindow.startMove();
}
	
// Close button
function doClose()
{
  // Close Settings window if it was left open
  if(stngWnd != null) stngWnd.window.close();
  window.nativeWindow.close();
  onWindowClose();
}	

function doCloseDown()
{
  $( 'btnClose' ).src = 'images/close.gif';	
  $( 'divClose' ).style.top = '5px';
}

function doCloseOut()
{
  $( 'btnClose' ).src = 'images/close.gif';
  $( 'divClose' ).style.top = '4px';	
}

function doCloseOver()
{
  $( 'btnClose' ).src = 'images/close_hot.gif';
}
	
// Maximize button
function doMax()
{
	if( max )
	{
		window.nativeWindow.restore();		
		max = false;
	} else {
		window.nativeWindow.maximize();		
		max = true;		
	}

	$( 'btnMax' ).src = 'images/max.gif';
	$( 'divMax' ).style.top = '4px';	
}	

function doMaxDown()
{
	$( 'btnMax' ).src = 'images/max.gif';	
	$( 'divMax' ).style.top = '5px';
}

function doMaxOut()
{
	$( 'btnMax' ).src = 'images/max.gif';
	$( 'divMax' ).style.top = '4px';	
}

function doMaxOver()
{
	$( 'btnMax' ).src = 'images/max_hot.gif';
}	

// Set of methods to manage systray
function doMinToSystrayDown()
{
  $( 'btnMinToSystray' ).src = 'images/mintosys.gif';	
  $( 'divMinToSystray' ).style.top = '5px';
}

function doMinToSystrayOut()
{
  $( 'btnMinToSystray' ).src = 'images/mintosys.gif';
  $( 'divMinToSystray' ).style.top = '4px';	
}

function doMinToSystrayOver()
{
  $( 'btnMinToSystray' ).src = 'images/mintosys_hot.gif';
}	

//***************************************************************************
// Systray icon load complete event handler. Refer to the event handler registration in 
// minimizeToTray()
//***************************************************************************
var iconLoadComplete = function(event) 
{ 
  air.NativeApplication.nativeApplication.icon.bitmaps = new runtime.Array(event.target.content.bitmapData); 
}

//***************************************************************************
// The function gets called when a user selects Restore systray menu item
//***************************************************************************
var restoreAppWindow = function(event)
{
  window.nativeWindow.visible = true; // Enable the app's taskbar
  window.focus(); // Bring in on top
  // Check if the systray icon should be still displayed
  if(!config.getBoolParameter('alwaysShowTrayIconStng'))
    air.NativeApplication.nativeApplication.icon.bitmaps = []; // Remove icon
}

//***************************************************************************
// OnClick event handler for Minimize button (id=btnMinToSystray)
//***************************************************************************
function doMinToSystray()
{
  // 1. Check if a user's PC supports systray functionality
  if(air.NativeApplication.supportsSystemTrayIcon) 
  { 
    // 2. Add icon
    var iconLoad = new air.Loader(); 
    // 2.1 Register event handler to process the event an icon is loaded
    iconLoad.contentLoaderInfo.addEventListener(air.Event.COMPLETE,iconLoadComplete); 
    // 2.2 Start loading a systray icon
    iconLoad.load(new air.URLRequest("icons/wizehive-16.png")); 
    air.NativeApplication.nativeApplication.icon.tooltip = "WizeHive.com"; 
    // 3. Add systray menu items
    var iconMenu = new air.NativeMenu(); 
    // 3.1 Add Restore menu and its handler
    var restoreCommand = iconMenu.addItem(new air.NativeMenuItem("Restore")); 
    restoreCommand.addEventListener(air.Event.SELECT, restoreAppWindow); 
    air.NativeApplication.nativeApplication.icon.menu = iconMenu; 
    // 4. Hide the applcation taskbar
    window.nativeWindow.visible = false;
  }
}

// Minimize button
function doMin()
{
  if(config.getBoolParameter('sendWindowToTrayStng') && air.NativeApplication.supportsSystemTrayIcon)
  {
    doMinToSystray();
  }
  else
  {
    if(min)
    {
      window.nativeWindow.restore();		
      min = false;
    } 
    else 
    {
      window.nativeWindow.minimize();		
      min = true;		
    }

    $( 'btnMin' ).src = 'images/min.gif';
    $( 'divMin' ).style.top = '4px';	
  }
}	

function doMinDown()
{
	$( 'btnMin' ).src = 'images/min.gif';	
	$( 'divMin' ).style.top = '5px';
}

function doMinOut()
{
	$( 'btnMin' ).src = 'images/min.gif';
	$( 'divMin' ).style.top = '4px';	
}

function doMinOver()
{
	$( 'btnMin' ).src = 'images/min_hot.gif';
}	

// Resizing
function doResizeBottom()
{
	window.nativeWindow.startResize( air.NativeWindowResize.BOTTOM );			
}

function doResizeBottomLeft()
{
	window.nativeWindow.startResize( air.NativeWindowResize.BOTTOM_LEFT );			
}

function doResizeHandle()
{
  window.nativeWindow.startResize( air.NativeWindowResize.BOTTOM_RIGHT );	
}

function doResizeLeft()
{
	window.nativeWindow.startResize( air.NativeWindowResize.LEFT );			
}

function doResizeRight()
{
	window.nativeWindow.startResize( air.NativeWindowResize.RIGHT );				
}

function doResizeTop()
{
	window.nativeWindow.startResize( air.NativeWindowResize.TOP );				
}

function resize() {
  if ($('entrybox')) {
	  var tmph2 = window.nativeWindow.height;
	  var pct = (tmph2>650)?15:(tmph2/35);
    var tmph = Math.round(tmph2/650*pct);
  	$('entrybox').style.height = tmph+'%';
  }
}

// Initialization	
function doLoadStyle()
{
	// Close button
	Event.observe('divClose', 'mouseover', doCloseOver);
	Event.observe('divClose', 'mousedown', doCloseDown);	
	Event.observe('divClose', 'mouseout', doCloseOut);	
	Event.observe('divClose', 'click', doClose);		
	
	// Maximize button
	Event.observe('divMax', 'mouseover', doMaxOver);
	Event.observe('divMax', 'mousedown', doMaxDown);	
	Event.observe('divMax', 'mouseout', doMaxOut);	
	Event.observe('divMax', 'click', doMax);			
	
	// Minimize button
	Event.observe('divMin', 'mouseover', doMinOver);
	Event.observe('divMin', 'mousedown', doMinDown);	
	Event.observe('divMin', 'mouseout', doMinOut);	
	Event.observe('divMin', 'click', doMin);				

	// Minimize to Systray button
        /*
        if(air.NativeApplication.supportsSystemTrayIcon) 
        { 
          Event.observe('divMinToSystray', 'mouseover', doMinToSystrayOver);
	  Event.observe('divMinToSystray', 'mousedown', doMinToSystrayDown);	
	  Event.observe('divMinToSystray', 'mouseout', doMinToSystrayOut);	
	  Event.observe('divMinToSystray', 'click', doMinToSystray);				
        }
        else
        {
          // If Systray is not supported the button will be removed
          Event.observe('divMinToSystray' ).hide();
        }
        */
	
	// Resizing (from handle, counter-clockwise)
	Event.observe('divHandle', 'mousedown', doResizeHandle);
	Event.observe('divTop', 'mousedown', doResizeTop);		

	// Move window
	Event.observe('divBar', 'mousedown', doBar);						
}

function WizeHiveAPI(key, shared_secret, token){
   var auth_url = server+'/services/auth/?';
   var rest_url = server+'/services/rest/?';
   var key = key;
   var token = token;
   var shared_secret = shared_secret;
   var xmlhttp = null;

   this.getLoginURL = function(perms,frob){
    	var url = auth_url;
    	var params = {'api_key':key,'frob':frob,'perms':perms};
    	var sig2 = "api_key" + key + "frob" + frob + "perms" + perms;
    	url += "api_key=" + key + "&frob=" + frob + "&perms=" + perms + "&api_sig=" + getSig(params,sig2);
    	
      return url;
   }

   this.callMethod = function(method, params, rtype){
	   return _call(method, params, rtype);
   }

   function _call(method, params, rtype){
    	var url = rest_url;
    	if (!rtype) rtype = "GET";
    	params['method'] = method;
    	params['api_key'] = key;
    	var tmp = new Array();
    	var x= 0;
    	for(key2 in params){
    	  x++;
    		tmp[x] = key2; 
    	}
    	tmp.sort();
    	var params2 = '';
    	var sig2 = '';
    	var postParams = '';
    	tmp.each(function (el) {
    	  sig2 += el + encode_utf8(params[el]);
        if (rtype=='POST') postParams += "&" + el + "=" + URLEncode(params[el]);
        else url += "&" + el + "=" + URLEncode(params[el]);
      });
      if (rtype=='POST') postParams += "&api_sig=" + getSig(params2,sig2);
    	else url += "&api_sig=" + getSig(params2,sig2);
        air.trace(url);
    	xmlhttp = xmlHttpCreate();
    	xmlhttp.open(rtype, url, false);
    	if (rtype=='POST') {
    	 xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded; Charset=UTF-8');
       xmlhttp.setRequestHeader("Content-Length", postParams.length);//binaryLength_UTF8(postParams2));
       xmlhttp.setRequestHeader("Connection", "close");
      }
    	//air.trace(rtype+' url='+url+"\n");
    	xmlhttp.send(postParams); 
    	  if (rtype=='POST') {air.trace(postParams);
        air.trace('response='+xmlhttp.responseText);}
      
    	return xmlhttp.responseText;
   }
   

   function getSig(params,signa){
    	var sig = shared_secret+signa;// + "api_key" + key;// +  "perms" + perms; 
air.trace(sig);air.trace(hex_md5(sig));
    	return hex_md5(sig);
   }

   function xmlHttpCreate(){
    	var req = null;
    	try{
                    req = new ActiveXObject("Msxml2.XMLHTTP");
            }
            catch(e){
                    try{
                            req = new ActiveXObject("Microsoft.XMLHTTP");
                    }
                    catch(sc){
                            req=null;
                    }
            }
            if(!req && typeof XMLHttpRequest != "undefined"){
                    req = new XMLHttpRequest();
            }
    	return req; 
   }
   
   function URLEncode (str) {
      return encodeURIComponent(encode_utf8( str ));//escape(str);
      //return encode_utf8( str );
    }

   
}

function encode_utf8( s )
{
  return unescape( encodeURIComponent( s ) );
}

function binaryLength_UTF8(str)
{	
	var bytes, charCode, a, len;
	
	bytes = 0;
	for (a = 0, len = str.length; a < len; a++)
	{
		charCode = str.charCodeAt(a);
		if (charCode < 128) //2^7
			bytes += 1;
		else if (charCode < 2048) // 2^11
			bytes += 2;
		else if (charCode < 65536) // 2^16
			bytes += 3;
		else
			bytes += 4;
	}
	
	return bytes;
}

function jsGet(type){
  if(location.href.match(type)){
    return location.href.split(type+'=')[1].split('-')[0];
  }
}
