//***************************************************************************
// The file has dependencies on prototype.js and config.js. Make sure to include
// them first.
//***************************************************************************
var config = new AppConfig();
//var config = new AppConfig('COOKIE');
//var config = new AppConfig('FILE');
// The following 4 flags are used to prevent reloading settings from the stored configuration
// and overriding new settings specified by a user. So the settings are loaded from the configuration
// only once.
var accountLoaded = false;
var tasksLoaded = false;
var activityLoaded = false;
var otherLoaded = false;
var settingsWndClosed = false;
var currentTab = '';
var preservedSettings = new Hash();

//***************************************************************************
// Loads all setings from the locally stored configuration. The function is
// called from onajaxpageload every time a tab is clicked.
//***************************************************************************
function loadSettings(tab)
{
  currentTab = tab;
  if(tab == 'tasks') 
  {
    if(!tasksLoaded)
    {
      // Second Line Options
      $('showSecondLineStngYes').checked = config.getBoolParameter('showSecondLineStngYes');
      $('showSecondLineStngNo').checked = config.getBoolParameter('showSecondLineStngNo');
      $('showScndLinePersonStng').checked = config.getBoolParameter('showScndLinePersonStng');
      $('showScndLineWsStng').checked = config.getBoolParameter('showScndLineWsStng');
      $('showScndLineDueDateStng').checked = config.getBoolParameter('showScndLineDueDateStng');
      $('showScndLinePageStng').checked = config.getBoolParameter('showScndLinePageStng');
      $('showScndLineStatusStng').checked = config.getBoolParameter('showScndLineStatusStng');
      $('showScndLineCategoryStng').checked = config.getBoolParameter('showScndLineCategoryStng');
      $('showScndLinePriorityStng').checked = config.getBoolParameter('showScndLinePriorityStng');
       // Characters to display
      $('showTaskCharactersStng').value = config.getStringParameter('showTaskCharactersStng');
      // Whose Tasks Options
      $('whoseTasksMyStng').checked = config.getBoolParameter('whoseTasksMyStng');
      $('whoseTasksEveryoneStng').checked = config.getBoolParameter('whoseTasksEveryoneStng');
      // Status Options
      $('statusOpenStng').checked = config.getBoolParameter('statusOpenStng');
      $('statusInProgressStng').checked = config.getBoolParameter('statusInProgressStng');
      $('statusCompletedStng').checked = config.getBoolParameter('statusCompletedStng');
      $('statusArchivedStng').checked = config.getBoolParameter('statusArchivedStng');
      // Due Date Options
      $('ddOverdueStng').checked = config.getBoolParameter('ddOverdueStng');
      $('ddTodayStng').checked = config.getBoolParameter('ddTodayStng');
      $('ddTomorrowStng').checked = config.getBoolParameter('ddTomorrowStng');
      $('ddNextWeekStng').checked = config.getBoolParameter('ddNextWeekStng');
      $('ddAllOthersStng').checked = config.getBoolParameter('ddAllOthersStng');
      
      //priority select
      selected = config.getIntParameter('prioritySelection');
      if ($('prtyTskFltrOp'+selected)) $('prtyTskFltrOp'+selected).selected = true;
      
      //taskTab.populateLists(api.token);
      var tmpsls = config.getStringParameter('taskListsSelect');
      $('catTskFltr').update(tmpsls);
      var selected2 = config.getIntParameter('categorySelection');
      if ($('catTskFltrOp'+selected2)) $('catTskFltrOp'+selected2).selected = true;
      
      tasksLoaded = true;
    }
    else
    {
      restoreSettings(tab);
    }
    // (Re)attaching event handlers
    
    //selected = config.getIntParameter('prioritySelection');
    //for(var i=0; i < $('prtyTskFltr').length; i++)
    //  if($('prtyTskFltr')[i].value == selected) { $('prtyTskFltr').selectedIndex = i; break; }
      
    // 1.5.2 Attach onchange event handler
    //moving this to preserveSettings
    //Event.observe('prtyTskFltr', 'change', function(){taskTab.changeFilter('prioritySelection', 'prtyTskFltr');});

    
  }
  else if(tab == 'activity')
  {
    if(!activityLoaded)
    {
      $('displayPicturesStng').checked = config.getBoolParameter('displayPicturesStng');
      $('showNotesCharactersStng').value = config.getStringParameter('showNotesCharactersStng');
      $('noteTypePostStng').checked = config.getBoolParameter('noteTypePostStng');
      $('noteTypeTaskStng').checked = config.getBoolParameter('noteTypeTaskStng');
      $('noteTypePostByEmailStng').checked = config.getBoolParameter('noteTypePostByEmailStng');
      $('noteTypeReplyStng').checked = config.getBoolParameter('noteTypeReplyStng');
      activityLoaded = true;
    }
    else
    {
      restoreSettings(tab);
    }
    // (Re)attaching event handlers
  }
  else if(tab == 'other')
  {
    if(!otherLoaded)
    {
      $('updateIntervalStng').value = config.getStringParameter('updateIntervalStng');
      $('showNewUpdateAlertStng').checked = config.getBoolParameter('showNewUpdateAlertStng');
      $('displayAlertIntervalStng').value = config.getStringParameter('displayAlertIntervalStng');
      $('sendWindowToTrayStng').checked = config.getBoolParameter('sendWindowToTrayStng');
      $('alwaysShowTrayIconStng').checked = config.getBoolParameter('alwaysShowTrayIconStng');
      $('launchOnStartupStng').checked = config.getBoolParameter('launchOnStartupStng');
      //$('defaultFontSizeStng').value = config.getStringParameter('defaultFontSizeStng');
      otherLoaded = true;
    }
    else
    {
      restoreSettings(tab);
    }
    // (Re)attaching event handlers
  }
}

//***************************************************************************
// When a user moves from one tab to another and because we load new tabs using
// ajax whatever settings the user has changed on the previous tab will be lost.
// The function preserves the settings in preservedSettings hash. The function is
// called from onbeforeajaxpageload event handler that is executed right before
// a new tab gets loaded.
//***************************************************************************
function preserveSettings(tab)
{
  if(tab == 'tasks') 
  {
    preservedSettings.set('showSecondLineStngYes', $('showSecondLineStngYes').checked);
    preservedSettings.set('showSecondLineStngNo', $('showSecondLineStngNo').checked);
    preservedSettings.set('showScndLinePersonStng', $('showScndLinePersonStng').checked);
    preservedSettings.set('showScndLineWsStng', $('showScndLineWsStng').checked);
    preservedSettings.set('showScndLineDueDateStng', $('showScndLineDueDateStng').checked);
    preservedSettings.set('showScndLinePageStng', $('showScndLinePageStng').checked);
    preservedSettings.set('showScndLineStatusStng', $('showScndLineStatusStng').checked);
    preservedSettings.set('showScndLineCategoryStng', $('showScndLineCategoryStng').checked);
    preservedSettings.set('showScndLinePriorityStng', $('showScndLinePriorityStng').checked);
    preservedSettings.set('whoseTasksMyStng', $('whoseTasksMyStng').checked);
    preservedSettings.set('whoseTasksEveryoneStng', $('whoseTasksEveryoneStng').checked);
    preservedSettings.set('statusOpenStng', $('statusOpenStng').checked);
    preservedSettings.set('statusInProgressStng', $('statusInProgressStng').checked);
    preservedSettings.set('statusCompletedStng', $('statusCompletedStng').checked);
    preservedSettings.set('statusArchivedStng', $('statusArchivedStng').checked);
    preservedSettings.set('showTaskCharactersStng', $('showTaskCharactersStng').value);
    preservedSettings.set('ddOverdueStng', $('ddOverdueStng').checked);
    preservedSettings.set('ddTodayStng', $('ddTodayStng').checked);
    preservedSettings.set('ddTomorrowStng', $('ddTomorrowStng').checked);
    preservedSettings.set('ddNextWeekStng', $('ddNextWeekStng').checked);
    preservedSettings.set('ddAllOthersStng', $('ddAllOthersStng').checked);
    preservedSettings.set('prioritySelection', $F('prtyTskFltr'));
    preservedSettings.set('categorySelection', $F('catTskFltr'));
  }
  else if(tab == 'activity')
  {
    preservedSettings.set('displayPicturesStng', $('displayPicturesStng').checked);
    preservedSettings.set('showNotesCharactersStng', $('showNotesCharactersStng').value);
    preservedSettings.set('noteTypePostStng', $('noteTypePostStng').checked);
    preservedSettings.set('noteTypeTaskStng', $('noteTypeTaskStng').checked);
    preservedSettings.set('noteTypePostByEmailStng', $('noteTypePostByEmailStng').checked);
    preservedSettings.set('noteTypeReplyStng', $('noteTypeReplyStng').checked);
  }
  else if(tab == 'other')
  {
    preservedSettings.set('updateIntervalStng', $('updateIntervalStng').value);
    preservedSettings.set('showNewUpdateAlertStng', $('showNewUpdateAlertStng').checked);
    preservedSettings.set('displayAlertIntervalStng', $('displayAlertIntervalStng').value);
    preservedSettings.set('sendWindowToTrayStng', $('sendWindowToTrayStng').checked);
    preservedSettings.set('alwaysShowTrayIconStng', $('alwaysShowTrayIconStng').checked);
    preservedSettings.set('launchOnStartupStng', $('launchOnStartupStng').checked);
    //preservedSettings.set('defaultFontSizeStng', $('defaultFontSizeStng').value);
  }
}

//***************************************************************************
// When a user moves from one tab to another and because we load new tabs using
// ajax the settings earlier preserved un the function preserveSettings need
// to be restored. The function is called from loadSettings() during the ajax
// page load. 
//***************************************************************************
function restoreSettings(tab)
{
  if(tab == 'tasks') 
  {
    $('showSecondLineStngYes').checked = preservedSettings.get('showSecondLineStngYes');
    $('showSecondLineStngNo').checked = preservedSettings.get('showSecondLineStngNo');
    $('showScndLinePersonStng').checked = preservedSettings.get('showScndLinePersonStng');
    $('showScndLineWsStng').checked = preservedSettings.get('showScndLineWsStng');
    $('showScndLineDueDateStng').checked = preservedSettings.get('showScndLineDueDateStng');
    $('showScndLinePageStng').checked = preservedSettings.get('showScndLinePageStng');
    $('showScndLineStatusStng').checked = preservedSettings.get('showScndLineStatusStng');
    $('showScndLineCategoryStng').checked = preservedSettings.get('showScndLineCategoryStng');
    $('showScndLinePriorityStng').checked = preservedSettings.get('showScndLinePriorityStng');
    $('whoseTasksMyStng').checked = preservedSettings.get('whoseTasksMyStng');
    $('whoseTasksEveryoneStng').checked = preservedSettings.get('whoseTasksEveryoneStng');
    $('statusOpenStng').checked = preservedSettings.get('statusOpenStng');
    $('statusInProgressStng').checked = preservedSettings.get('statusInProgressStng');
    $('statusCompletedStng').checked = preservedSettings.get('statusCompletedStng');
    $('statusArchivedStng').checked = preservedSettings.get('statusArchivedStng');
    $('showTaskCharactersStng').value = preservedSettings.get('showTaskCharactersStng');
    $('ddOverdueStng').checked = preservedSettings.get('ddOverdueStng');
    $('ddTodayStng').checked = preservedSettings.get('ddTodayStng');
    $('ddTomorrowStng').checked = preservedSettings.get('ddTomorrowStng');
    $('ddNextWeekStng').checked = preservedSettings.get('ddNextWeekStng');
    $('ddAllOthersStng').checked = preservedSettings.get('ddAllOthersStng');   
    selected = config.getIntParameter('prioritySelection');
    if ($('prtyTskFltrOp'+selected)) $('prtyTskFltrOp'+selected).selected = true;
    
    var tmpsls = config.getStringParameter('taskListsSelect');
    $('catTskFltr').update(tmpsls);
    var selected2 = config.getIntParameter('categorySelection');
    if ($('catTskFltrOp'+selected2)) $('catTskFltrOp'+selected2).selected = true;
  }
  else if(tab == 'activity')
  {
    $('displayPicturesStng').checked = preservedSettings.get('displayPicturesStng');
    $('showNotesCharactersStng').value = preservedSettings.get('showNotesCharactersStng');
    $('noteTypePostStng').checked = preservedSettings.get('noteTypePostStng');
    $('noteTypeTaskStng').checked = preservedSettings.get('noteTypeTaskStng');
    $('noteTypePostByEmailStng').checked = preservedSettings.get('noteTypePostByEmailStng');
    $('noteTypeReplyStng').checked = preservedSettings.get('noteTypeReplyStng');
  }
  else if(tab == 'other')
  {
    $('updateIntervalStng').value = preservedSettings.get('updateIntervalStng');
    $('showNewUpdateAlertStng').checked = preservedSettings.get('showNewUpdateAlertStng');
    $('displayAlertIntervalStng').value = preservedSettings.get('displayAlertIntervalStng');
    $('sendWindowToTrayStng').checked = preservedSettings.get('sendWindowToTrayStng');
    $('alwaysShowTrayIconStng').checked = preservedSettings.get('alwaysShowTrayIconStng');
    $('launchOnStartupStng').checked = preservedSettings.get('launchOnStartupStng');
    //$('defaultFontSizeStng').value = preservedSettings.get('defaultFontSizeStng');
  }
}

//***************************************************************************
// Is called from onclick handlers for OK/Cancel buttons and stores changed
// parameters in the local configuration in case of OK button.
//***************************************************************************
function closeSettings(update)
{
  if(update != 'cancel')
  {
    var settingsChanged = 0;
    var launchOnStart = 0;
    // 1. Collect and check parameters from preserved parameters array
    var newValue;
    var storedValue;
    preservedSettings.each(function(pair) {
      newValue = pair.value;
      if(newValue != null)
      {
        storedValue = config.getStringParameter(pair.key);
        if(newValue != storedValue)
        {
          settingsChanged++;
          config.setParameter(pair.key, newValue);
        }
      }
    });
    // 2. Collect and check parameters from the current tab
    var key;
    if(currentTab == 'tasks')
    {
      // Check if any settings were changed in Tasks tab
      settingsChanged += validateCheckParameter('showSecondLineStngYes');
      settingsChanged += validateCheckParameter('showSecondLineStngNo');
      settingsChanged += validateCheckParameter('showScndLinePersonStng');
      settingsChanged += validateCheckParameter('showScndLineWsStng');
      settingsChanged += validateCheckParameter('showScndLineDueDateStng');
      settingsChanged += validateCheckParameter('showScndLinePageStng');
      settingsChanged += validateCheckParameter('showScndLineStatusStng');
      settingsChanged += validateCheckParameter('showScndLineCategoryStng');
      settingsChanged += validateCheckParameter('showScndLinePriorityStng');
      settingsChanged += validateCheckParameter('whoseTasksMyStng');
      settingsChanged += validateCheckParameter('whoseTasksEveryoneStng');
      settingsChanged += validateCheckParameter('statusOpenStng');
      settingsChanged += validateCheckParameter('statusInProgressStng');
      settingsChanged += validateCheckParameter('statusCompletedStng');
      settingsChanged += validateCheckParameter('statusArchivedStng');
      settingsChanged += validateValueParameter('showTaskCharactersStng');
      settingsChanged += validateCheckParameter('ddOverdueStng');
      settingsChanged += validateCheckParameter('ddTodayStng');
      settingsChanged += validateCheckParameter('ddTomorrowStng');
      settingsChanged += validateCheckParameter('ddNextWeekStng');
      settingsChanged += validateCheckParameter('ddAllOthersStng'); 
      settingsChanged += (config.getIntParameter('prioritySelection')!=$F('prtyTskFltr')); 
      config.setParameter('prioritySelection', $F('prtyTskFltr'));
      settingsChanged += (config.getIntParameter('categorySelection')!=$F('catTskFltr')); 
      config.setParameter('categorySelection', $F('catTskFltr'));
    }
    else if(currentTab == 'activity')
    {
      settingsChanged += validateCheckParameter('displayPicturesStng');
      settingsChanged += validateValueParameter('showNotesCharactersStng');
      settingsChanged += validateCheckParameter('noteTypePostStng');
      settingsChanged += validateCheckParameter('noteTypeTaskStng');
      settingsChanged += validateCheckParameter('noteTypePostByEmailStng');
      settingsChanged += validateCheckParameter('noteTypeReplyStng');
    }
    else if(currentTab == 'other')
    {
      settingsChanged += validateValueParameter('updateIntervalStng');
      settingsChanged += validateCheckParameter('showNewUpdateAlertStng');
      settingsChanged += validateValueParameter('displayAlertIntervalStng');
      settingsChanged += validateCheckParameter('sendWindowToTrayStng');
      settingsChanged += validateCheckParameter('alwaysShowTrayIconStng');
      launchOnStart = validateCheckParameter('launchOnStartupStng');
      settingsChanged += launchOnStart;
      //settingsChanged += validateValueParameter('defaultFontSizeStng');
    }
    if(settingsChanged > 0)
    {
      // config.setParameter('settingsChanged', settingsChanged);
      // 3. Separately process launchOnStartupStng settings
      if(launchOnStart > 0)
      { 
        try
        { 
          air.NativeApplication.nativeApplication.startAtLogin = $('launchOnStartupStng').checked; 
        } 
        catch(e) 
        { 
          alert('Cannot change Launch on startup option (' + $('launchOnStartupStng').checked + '): ' + e.message); 
        }
      }
      config.commit();
      // 4. Reload the content of the main window 
      window.opener.getActivity(1);
    }
  }
  doClose();
}

//***************************************************************************
// The function checks if a checkbox/radio element value of a parameter is 
// different from that stored locally. If it is a new value from the element
// will be stored locally
//***************************************************************************
function validateCheckParameter(key)
{
  var returnC;
  if($(key).checked != config.getStringParameter(key))
  {
    config.setParameter(key, $(key).checked);
    returnC = 1;
  }
  else
  {
    returnC = 0;
  }
  return returnC;
}

//***************************************************************************
// The function checks if a string element value of a parameter is 
// different from that stored locally. If it is a new value from the element
// will be stored locally
//***************************************************************************
function validateValueParameter(key)
{
  if($(key).value != config.getStringParameter(key))
  {
    config.setParameter(key, $(key).value);
    return 1;
  }
  else
  {
    return 0;
  }
}

// Close button
function doClose()
{
  window.nativeWindow.visible = false;
  // There is a chance a user might come back to change the settings
  // in which case we need to reload parameters that could have been
  // changed in the main window. For example, My/Everyone task. This is
  // done in on focus handler for the settings window
  settingsWndClosed = true;
}	

function doCloseDown()
{
  $( 'btnClose' ).src = 'images/close.gif';	
  $( 'divClose' ).style.top = '5px';
}

function doCloseOut()
{
  $( 'btnClose' ).src = 'images/close.gif';
  $( 'divClose' ).style.top = '4px';	
}

function doCloseOver()
{
  $( 'btnClose' ).src = 'images/close_hot.gif';
}

// Move window by grabbing bar
function doTitleBar()
{
  window.nativeWindow.startMove();	
}

function doLoadStyle()
{
  // Close button
  $( 'divClose' ).addEventListener( 'mouseover', doCloseOver, false );
  $( 'divClose' ).addEventListener( 'mousedown', doCloseDown, false );	
  $( 'divClose' ).addEventListener( 'mouseout', doCloseOut, false );	
  $( 'divClose' ).addEventListener( 'click', doClose, false );		
  // Title bar
  $( 'titleBar' ).addEventListener( 'mousedown', doTitleBar );
}

function doLoad()
{
  // Load Style
  doLoadStyle();
  // Check which tab to go to 
  var initTab = config.getStringParameter('initialSettingsTab');
  if(initTab != '')
    document.getElementById(initTab).onclick();
  // Attach onfocus handler that will be reloading parameters changed in the
  // main window, if necessary
  window.onfocus = reloadSettings;
}

//***************************************************************************
// The function reloads parameters changed in the main window in case when 
// previously a user closed the settings window
//***************************************************************************
function reloadSettings()
{
  if(settingsWndClosed)
  {
    settingsWndClosed = false;
    // Whose Tasks Options
    if(preservedSettings.get('whoseTasksMyStng') != null)
      preservedSettings.set('whoseTasksMyStng', config.getBoolParameter('whoseTasksMyStng'));
    if(preservedSettings.get('whoseTasksEveryoneStng') != null)
      preservedSettings.set('whoseTasksEveryoneStng', config.getBoolParameter('whoseTasksEveryoneStng'));
    $('whoseTasksMyStng').checked = config.getBoolParameter('whoseTasksMyStng');
    $('whoseTasksEveryoneStng').checked = config.getBoolParameter('whoseTasksEveryoneStng');
  }
}

function load()
{
  setTimeout(doLoad,1);
}
