function TaskTab(config, api)
{
  this.config;
  this.api = api;
  var cats;  //current pages
  var lists;  //current lists
  if(config == null) this.config = new AppConfig();
  else this.config = config;
  this.dragdrop = {sourceId:'', targetId:'', transferred:false};
  //this.loadList();


  //***************************************************************************
  // The method loads lists for a user.
  //***************************************************************************
  this.populateLists = function(token)
  {
    // 1. Pull lists
    var ops = '<option id="catTskFltrOp0" value="0" >List - All</option>';
    var selWrkSpace = this.config.getIntParameter('wsSelection');
    if(selWrkSpace != 0)
    {
      if (!lists) {
        var tmpJSON = this.api.callMethod('wizehive.tasks.lists.getList',{'format':'json','token':token});
        //air.trace(tmpJSON);
        var tmpLists = tmpJSON.evalJSON(true);
        lists = tmpLists.lists;
      }
      if(lists != null)
      {
        lists.each(function (element) {
          if (element['workspace_id']==selWrkSpace)  ops += '<option id="catTskFltrOp'+element['id']+'" value="'+element['id']+'">'+element['name']+'</option>'; 
        });
      }
    }
    if ($('catTskFltr')) {
      $('catTskFltr').update(ops);
      // 2. Set selected value from application configuration
      selected = this.config.getStringParameter('categorySelection'); 
      for(var i=0; i < $('catTskFltr').length; i++)
        if($('catTskFltr')[i].value == selected) { $('catTskFltr').selectedIndex = i; break; }
  
      // 3. Attach onchange event handler
      Event.stopObserving('catTskFltr');
      Event.observe('catTskFltr', 'change', function(){taskTab.changeFilter('categorySelection', 'catTskFltr');});
    }
    config.setParameter('taskListsSelect', ops);
    //reset the selection, so doesn't carry over from differnt workspace
    config.setParameter('categorySelection',0);
  }

  //***************************************************************************
  // The onchange handler for dropdown boxes used to filter out tasks in the
  // Tasks tab
  //***************************************************************************
  this.changeFilter = function(param, filter)
  {
    // 1. Update app configuration
    // Who Filter requires specific processing
    if(filter == 'whoTskFltr')
    {
      if($F('whoTskFltr') == 'Everyone')
      {
        this.config.setParameter('whoseTasksEveryoneStng', true);
        this.config.setParameter('whoseTasksMyStng', false);
      }
      else
      {
        this.config.setParameter('whoseTasksEveryoneStng', false);
        this.config.setParameter('whoseTasksMyStng', true);
      }
    }
    else
      this.config.setParameter(param, $F(filter));
    this.config.commit();
    if(filter == 'wsFltr')
    {
      this.populatePageDropdown($F(filter));
      this.populateLists(this.api.token);
    }
    // 2. Populate tasks
    this.populateTasks();
  }

  //***************************************************************************
  // The function populates Page dropdown in the Task tab.
  //***************************************************************************
  this.populatePageDropdown = function(ws)
  {
    var ops = '<option id="pgFltrOp0" value="0" >All</option>';
    if(ws != 0)
    {
      if (!cats) {
        var tmpJSON = api.callMethod('wizehive.pages.getList',{'format':'json','token':api.token});
        air.trace(tmpJSON);
        var tmpCats = tmpJSON.evalJSON(true);
        cats = tmpCats.pages;
      }
      if(cats)
      {
        var selected = this.config.getIntParameter('pageSelection');
        cats.each(function (el) { 
            if(el['workspace_id'] == ws) 
            {
              if(selected == el['id'])
              {
                ops += '<option id="pgFltrOp'+el['id']+'" value="'+el['id']+'" selected >'+el['name']+'</option>'; 
              }
              else
              {
                ops += '<option id="pgFltrOp'+el['id']+'" value="'+el['id']+'">'+el['name']+'</option>'; 
              }
            }
          });
      }
    }
    else
    {
      // Reset page selection to 0
      this.config.setParameter('pageSelection', '0');
    }
    $('pgFltr').update(ops);
    Event.stopObserving('pgFltr', 'change');
    Event.observe('pgFltr', 'change', function(){taskTab.changeFilter('pageSelection', 'pgFltr');});
  }
  
  //***************************************************************************
  // The function populates tasks table in the Task tab.
  //***************************************************************************
  this.populateTasks = function()
  {
    // 1. Remove all tasks
    var tasksDiv = $('tasksDiv');
    tasksDiv.innerHTML = '';
    var taskTable = new Element("table", {'class':'sortable'});
    tasksDiv.appendChild(taskTable);
    // 2. Prepare options for JSON to apply filters
    var selectedGroup = this.config.getStringParameter('groupSelection');
    var selectedPriority = this.config.getIntParameter('prioritySelection');
    var selectedWho = (this.config.getBoolParameter('whoseTasksEveryoneStng') == true) ? 'Everyone' : 'Mine';
    var selectedCategory = this.config.getStringParameter('categorySelection');
  
    var options = {};
    options.format = 'json';
    options.token = this.api.token;
    if (this.config.getIntParameter('wsSelection') > 0) 
    {
      options.ws_id = this.config.getIntParameter('wsSelection');
    }
    if(this.config.getIntParameter('pageSelection') > 0) 
    {
      options.pg_id = this.config.getIntParameter('pageSelection');
    }
    //if(selectedGroup != 'Status')
    //{
      var optionStr = '';
      if(this.config.getBoolParameter('statusOpenStng')) optionStr = 'open';
      if(this.config.getBoolParameter('statusInProgressStng'))
        if(optionStr.length > 0) optionStr += ',inprogress';
        else optionStr = 'inprogress';
      if(this.config.getBoolParameter('statusCompletedStng'))
        if(optionStr.length > 0) optionStr += ',completed';
        else optionStr = 'completed';
      if(this.config.getBoolParameter('statusArchivedStng'))
        if(optionStr.length > 0) optionStr += ',archived';
        else optionStr = 'archived';
      options.status = optionStr;
    //}
    if(selectedWho == 'Mine')
    {
      options.res_id = 'mine';
    }
    options.per_page=500;
    //alert(options.status);
    var tmpJSON = this.api.callMethod('wizehive.tasks.getList', options);
    //air.trace(tmpJSON);
    var tmpTasks = tmpJSON.evalJSON(true);
    var tasks = tmpTasks.tasks;
    // 3. Group, populate tasks, and apply filters if specified
    if(selectedGroup == 'Priority')
    {
      tasks.sort(this.sortTasksByPriority);
    }
    else if(selectedGroup == 'Person')
    {
      tasks.sort(this.sortTasksByPerson);
    }
    else if(selectedGroup == 'Status')
    {
      tasks.sort(this.sortTasksByStatus);
    }
    else if(selectedGroup == 'Page')
    {
      tasks.sort(this.sortTasksByPage);
    }
    else if(selectedGroup == 'List')
    {
      tasks.sort(this.sortTasksByCategory);
    }
    else if(selectedGroup == 'Created by')
    {
      tasks.sort(this.sortTasksByCreatedBy);
    }
    else if(selectedGroup == 'Due date')
    {
      tasks.sort(this.sortTasksByDueDate);
    }
  
    var body;
    var groupValue, groupValueToStore;
    var currentGroupValue = '';
    var addTask;
    // 4. Load settings that determine what to show in the second line
    var secondLine = {showSecondLine:this.config.getBoolParameter('showSecondLineStngYes'),
                      showPerson:this.config.getBoolParameter('showScndLinePersonStng'),
                      showWs:this.config.getBoolParameter('showScndLineWsStng'),
                      showDueDate:this.config.getBoolParameter('showScndLineDueDateStng'),
                      showPage:this.config.getBoolParameter('showScndLinePageStng'),
                      showStatus:this.config.getBoolParameter('showScndLineStatusStng'),
                      showCategory:this.config.getBoolParameter('showScndLineCategoryStng'),
                      showPriority:this.config.getBoolParameter('showScndLinePriorityStng')};
    // Load Due Date settings
    var dd = {overDue:this.config.getBoolParameter('ddOverdueStng'), today:this.config.getBoolParameter('ddTodayStng'),
              tomorrow:this.config.getBoolParameter('ddTomorrowStng'), nextWeek:this.config.getBoolParameter('ddNextWeekStng'),
              allOthers:this.config.getBoolParameter('ddAllOthersStng')};
    var applyDDFltr = dd.overDue || dd.today || dd.tomorrow || dd.nextWeek || dd.allOthers;
    var taskDD, today, tomorrow, nextWeekStart, nextWeekEnd, monthDigits;
    taskDD = new Date(); today = new Date(); 
    tomorrow = new Date(); tomorrow.setDate(today.getDate() + 1); 
    nextWeekStart = new Date(); nextWeekStart.setDate(today.getDate() + (7 - today.getDay()));
    nextWeekEnd = new Date(); nextWeekEnd.setDate(today.getDate() + (7 - today.getDay()) + 6);
    
    // Load some other settings
    var charactersToShow = this.config.getIntParameter('showTaskCharactersStng');
    charactersToShow = (charactersToShow > 0)?charactersToShow:240;
    var personName;
    var pageCategory;
    var colspan = 2;
    var firstGroupRow = true; // The flag is used to make sure add quick panel is not added before the very first grouping line
    var groupedTasks = new Array(); // array used to pre-cache tasks from the same group, so that they can be ordered
    // 5. Define flags equivalent to filters
    var catFltr, prtyFltr, whoFltr, ddFltr;
    catFltr = true; prtyFltr = true; whoFltr = true; ddFltr = true;
    var div, taskStyle;
    var controlCellStyle = 'width:40px;';
    // 6. Process each task
    tasks.each(function (task) {
      //if(task.TaskNode.node.indexOf('test') != -1)
      //  air.trace('Task Text: [' + task.TaskNode.node + ']');
      //air.trace(task.TaskNode.page_id);
      // 6.1 Determine if a grouping row should be rendered first
      groupValueToStore = 'Uncategorized';
      if(selectedGroup == 'Priority')
      {
        groupValue = groupValueToStore = task.TaskNode.priority_id;
      }
      else if(selectedGroup == 'Person')
      {
        personName = task.Resource.email ? task.Resource.email : '';
        if(personName.indexOf('@') != -1) personName = personName.substring(0, personName.indexOf('@'));
        groupValue = personName;
        groupValueToStore = task.Resource.id;
      }
      else if(selectedGroup == 'Status')
      {
        groupValue = groupValueToStore = task.Status.status;
        groupValueToStore = (groupValueToStore == 'In Progress') ? 'InProgress' : groupValueToStore;
      }
      else if(selectedGroup == 'Page')
      {
        if(task.Page.name == null)
          groupValue = 'All';
        else
          groupValue = task.Page.name;
        groupValueToStore = (groupValue == 'All') ? '0' : groupValue;
      }
      else if(selectedGroup == 'List')
      {
        groupValue = task.List.name ? task.List.name : 'All';
        groupValueToStore = groupValue;
      }
      else if(selectedGroup == 'Created by')
      {
        groupValue = task.User.username;
        groupValueToStore = task.User.id;
      }
      else if(selectedGroup == 'Due date')
      {
        groupValue = (task.TaskNode.ar_date != '0000-00-00') ? task.TaskNode.ar_date : 'No Due Date';
        groupValueToStore = task.TaskNode.ar_date;
      }
      // Render a grouping row
      if((currentGroupValue != groupValue) && (selectedGroup != 0))
      {
        // But, first render tasks from the previous group
        // Sort by order
        groupedTasks.sort(taskTab.sortTasksByOrder);
        for(i = 0; i < groupedTasks.length; i++) taskTab.renderTask(groupedTasks[i], taskTable, charactersToShow, groupValueToStore, secondLine, controlCellStyle);
        groupedTasks = new Array(); // Clean up
        // Second, insert quick add panel
        if (false) //(!firstGroupRow) - taking out quick add for now
        {
          // Add quick add row
          div = new Element("div");
          row = new Element("tr");
          cell = new Element("td", {'style':controlCellStyle}); // blank control cell
          row.appendChild(cell);
          body = "<div id='taskQuickAddAction" + task.TaskNode.id + "' style='cursor:pointer;'>+ quick add</div><br/>";
          body += "<div id='taskQuickAddActionPanel" + task.TaskNode.id + "' class='taskquickaddpanel' style='display:none'>";
          body += "Press [ENTER] to save the entry<br/>"; 
          body += "<textarea id='taskQuickAddActionText" + task.TaskNode.id + 
                  "' style='border:1px solid black;'></textarea><input id='taskQuickAddActionSaveBtn" + task.TaskNode.id + 
                  "' type='button' value='Save'/><a id='taskQuickAddActionCloseLnk" + task.TaskNode.id + "' href='#'>Close</a>"; 
          body += "</div><span id='taskQuickAddGroup" + task.TaskNode.id + "' style='display:none;'>" + groupValueToStore + "</span>";
          cell = new Element("td").update(body);
          row.appendChild(cell);
          div.appendChild(row);
          taskTable.appendChild(div);
        }
        else firstGroupRow = false;
        displayGroupValue = (groupValue == null)?"":groupValue;
        // Add groupby row
        cell = new Element("td", {'style':'color:black;background-color:#FEF4B4;font-weight:bold;', 'colspan':'2'}).update(selectedGroup.toUpperCase() + ': ' + displayGroupValue.toUpperCase());
        row = new Element("tr");
        row.appendChild(cell);
        taskTable.appendChild(row);
        currentGroupValue = groupValue;
      }
      // 6.2 Determine if the task satisfies all filters
      prtyFltr = ((selectedPriority != 0) && (selectedPriority == task.TaskNode.priority_id)) || (selectedPriority == 0);
      catFltr = ((selectedCategory != 0) && (selectedCategory == task.List.id)) || (selectedCategory == 0);
      //alert('selectedCategory:'+selectedCategory+' task.List.name:'+task.List.name);
      if(applyDDFltr)
      {
        if((task.TaskNode.ar_date != null) && (task.TaskNode.ar_date.length > 0))
        {
          if(task.TaskNode.ar_date != '0000-00-00')
          {
            monthDigits = task.TaskNode.ar_date.substring(5, 7) - 1;
            monthDigits = (monthDigits == -1) ? 11 : monthDigits;
            taskDD.setFullYear(task.TaskNode.ar_date.substring(0, 4), monthDigits, task.TaskNode.ar_date.substring(8, 10));
            var todaycmpr = (taskDD.toDateString() == today.toDateString());
            
            ddFltr =  (dd.overDue && (taskDD < today)) || (dd.today && (todaycmpr)) || 
                      (dd.nextWeek && (taskDD >= nextWeekStart) && (taskDD <= nextWeekEnd)) || 
                      (dd.tomorrow && (taskDD.toDateString() == tomorrow.toDateString()));
            ddFltr |= dd.allOthers;
          }
          else
          {
            // Show tasks with no due dates only if allOthers flag is set
            ddFltr = dd.allOthers;
          }
        }
      } else ddFltr = true;
      if(prtyFltr && catFltr && ddFltr)
      {
        groupedTasks.push(task);
      }
    });
    // Add the last quick add row (taking out quick add for now - AMC 1/21/10)
    // But, first render tasks from the previous group
    // Sort by order
    groupedTasks.sort(this.sortTasksByOrder);
    for(i = 0; i < groupedTasks.length; i++) this.renderTask(groupedTasks[i], taskTable, charactersToShow, groupValueToStore, secondLine, controlCellStyle);
    /*div = new Element("div");
    row = new Element("tr");
    cell = new Element("td", {'style':controlCellStyle}); // blank control cell
    row.appendChild(cell);
    body = "<div id='taskQuickAddAction0000' style='cursor:pointer;'>+ quick add</div><br/>";
    body += "<div id='taskQuickAddActionPanel0000' class='taskquickaddpanel' style='display:none'>";
    body += "Press [ENTER] to save the entry<br/>"; 
    body += "<textarea id='taskQuickAddActionText0000' style='border:1px solid black;'></textarea><input id='taskQuickAddActionSaveBtn0000'" + 
            " type='button' value='Save'/><a id='taskQuickAddActionCloseLnk0000' href='#'>Close</a>"; 
    body += "</div><span id='taskQuickAddGroup0000' style='display:none;'>" + groupValueToStore + "</span>";
    cell = new Element("td").update(body);
    row.appendChild(cell);
    div.appendChild(row);
    taskTable.appendChild(div);
    Event.stopObserving('taskQuickAddAction0000');
    Event.observe('taskQuickAddAction0000', 'click', taskTab.onAddTaskQuickAction.bindAsEventListener(this, '0000') );
    */
  }

  this.sortTasksByPriority = function(a, b)
  {
    return a.TaskNode.priority_id - b.TaskNode.priority_id;
  }

  this.sortTasksByPerson = function(a, b)
  {
    //return a.Resource.email > b.Resource.email;
    //if(!a || !b || !a.Resource || b.Resource) return 0;
    aName = a.Resource.email ? a.Resource.email : ''; aName = aName.toLowerCase();
    bName = b.Resource.email ? b.Resource.email : ''; bName = bName.toLowerCase();
    return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
  }

  this.sortTasksByStatus = function(a, b)
  {
    return a.TaskNode.status_id - b.TaskNode.status_id;
  }

  this.sortTasksByPage = function(a, b)
  {
    return a.TaskNode.page_id - b.TaskNode.page_id;
  }

  this.sortTasksByCategory = function(a, b)
  {
    //a.Page.category = (a.Page.category != null) ? a.Page.category : 'All';
    //b.Page.category = (b.Page.category != null) ? b.Page.category : 'All';
    //return a.Page.category > b.Page.category;
    return a.TaskNode.list_id - b.TaskNode.list_id;
  }

  this.sortTasksByCreatedBy = function(a, b)
  {
    /*
    var x = a.User.username.toLowerCase();
    var y = b.User.username.toLowerCase();
    return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    */
    return a.User.id - b.User.id;
  }

  this.sortTasksByDueDate = function(a, b)
  {
    var y = (a.TaskNode.ar_date != '0000-00-00') ? a.TaskNode.ar_date : 'No Due Date';
    var x = (b.TaskNode.ar_date != '0000-00-00') ? b.TaskNode.ar_date : 'No Due Date';
    return ((x < y) ? -1 : ((x > y) ? 1 : 0));
  }

  this.sortTasksByOrder = function(a, b)
  {
    return a.TaskNode.order - b.TaskNode.order;
  }

  //***************************************************************************
  // The method is called from populateTasks to render all elements associated with
  // passed in task.
  //***************************************************************************
  this.renderTask = function(task, taskTable, charactersToShow, groupValueToStore, secondLine, controlCellStyle)
  {
    var showAtLeastOne = secondLine.showPerson || secondLine.showWs || secondLine.showDueDate || 
                         secondLine.showPage || secondLine.showStatus || secondLine.showCategory || 
                         secondLine.showPriority;
    var taskStartTag = '<span  class="taskop2">';
    var taskEndTag = '</span>';

    /* Change the background color depending on task status - not doing it
    taskStyle = 'background-color: white; margin-bottom:2px; margin-left:-3px; margin-top:-1px; margin-right:2px;';
    if(task.Status.status == 'Open')
      taskStyle += 'background-color: #ffffdd;';
    else if(task.Status.status == 'Completed')
      taskStyle += 'background-color: #ddffdd;';
    else if(task.Status.status == 'In Progress')
      taskStyle += 'background-color: #dddfff';
    else if(task.Status.status == 'Archived')
      taskStyle += 'background-color: #dddddf';
    div = new Element("div", {style:taskStyle});
    */
    var div = new Element("div", {id:'taskDiv' + task.TaskNode.id, style:'border-bottom: 1px solid #ccc;-webkit-user-drag:element;-webkit-user-select:none;cursor:move;'});
    // 6.3 Add task text row
    var row = new Element("tr", {id:'taskRow' + task.TaskNode.id, style:'-webkit-user-drag:element;'});
    // 6.3.1 Add cell with control links
    var body = "";var tbody = "";//"<a id='taskStatus" + task.TaskNode.id + "' href='#'>Status</a><br/>";
    // 6.3.1.1 Add context menu for Status link
    tbody += "<span id='taskStatusContextMenu" + task.TaskNode.id + "' class='taskscontextmenu' style='display:none'>";
    if(task.Status.status != 'Open')
      tbody += "<a id='changeTaskStatusToOpenLink" + task.TaskNode.id + "' href='#'>Open</a><br/>"; 
    if(task.Status.status != 'Completed')
      tbody += "<a id='changeTaskStatusToCompletedLink" + task.TaskNode.id + "' href='#'>Completed</a><br/>"; 
    if(task.Status.status != 'In Progress')
      tbody += "<a id='changeTaskStatusToInProgressLink" + task.TaskNode.id + "' href='#'>In Progress</a><br/>"; 
    if(task.Status.status != 'Archived')
      tbody += "<a id='changeTaskStatusToArchivedLink" + task.TaskNode.id + "' href='#'>Archived</a>"; 
    tbody += "</span>";
    // 6.3.1.2 Add context menu for Action link
    body += "<div id='taskAction" + task.TaskNode.id + "' style='opacity:0.45;cursor:pointer;color:blue;text-decoration:underline;font-size:80%'>actions</div>";
    //status color rectangle
    var scolor = '#fff';
    if (task.Status.status=='Completed') scolor = 'green';
    else if (task.Status.status=='In Progress') scolor = 'yellow';
    body += "<div id='taskStatusB" + task.TaskNode.id + "' style='border:1px solid #ccc;width:35px;height:8px;margin-top:3px;margin-bottom:2px;cursor:pointer;background-color:"+scolor+"'></div>";
    
    body += "<div id='taskActionContextMenu" + task.TaskNode.id + "' class='taskscontextmenu' style='display:none'>";
    body += "<a id='taskReplyActionLink" + task.TaskNode.id + "' href='#'>Reply</a><br/>"; 
    body += "<a id='taskEditActionLink" + task.TaskNode.id + "' href='#'>Edit</a><br/>"; 
    var linkid = 't'+task.TaskNode.id;
    var link = server+'/comments/view/'+linkid+"/"+task.TaskNode.id+"/3";
      
    body += "<a id='taskViewActionLink" + task.TaskNode.id + "' href='"+link+"' target='_blank'>View</a>"; 
    body += "</div>";
    cell = new Element("td", {'style':controlCellStyle, 'rowspan':'2'}).update(body);
    row.appendChild(cell);
    // 6.3.2 Add task text
    body = (task.TaskNode.node.length>charactersToShow)?(task.TaskNode.node.substr(0, charactersToShow) + '<a href="#" id="viewt' + task.TaskNode.id + '">...</a>'):task.TaskNode.node;
    body = "<span id='taskContentSpan" + task.TaskNode.id + "' style='-webkit-user-drag:none;cursor:text'>" + body + "</span>";
    // 6.3.3 Add reply link
    //body += ' <a href="#" id="reply' + task.TaskNode.id + '">reply</a>'; 
    // Save the task content in a hidden element so that it can be then edited by a user through Actions->Edit
    body += ' <span id="taskContent' + task.TaskNode.id + '" style="display:none">' + task.TaskNode.node + '</span>';
    // Save the task status in a hidden element so that it can be then populated if a user drags it somewhere else
    body += ' <span id="taskStatusValue' + task.TaskNode.id + '" style="display:none">' + task.Status.status + '</span>';
    // Save the task group in a hidden element so that it can be then updated if a user drags it into another group
    body += ' <span id="taskGroupValue' + task.TaskNode.id + '" style="display:none">' + groupValueToStore + '</span>';
    body += tbody;
    cell = new Element("td", {id:'taskText' + task.TaskNode.id, style:'-webkit-user-drag:none;-webkit-user-select:auto;'}).update(body);
    row.appendChild(cell);
    div.appendChild(row);
    // Add replies
    /* TBD
    getTaskThread(task.TaskNode.id);
    */
    // 6.4 Add second line
    if(secondLine.showSecondLine && showAtLeastOne)
    {
      body = '';var comma = '';
      row = new Element("tr");
      if(secondLine.showPerson)
      {
        personName = task.Resource.email;
        personName = personName ? personName : '';
        if(personName.indexOf('@') != -1) 
          personName = personName.substring(0, personName.indexOf('@'));
        body += taskStartTag + comma + 'Assigned to ' + personName + taskEndTag;
        comma = ', ';
      }
      if(secondLine.showWs) {
        var wsname = task.Workspace.group?task.Workspace.group:'Uncategorized';
        body += taskStartTag + comma + 'workspace:' + wsname + taskEndTag;
        comma = ', ';
      }
      if(secondLine.showDueDate)
      {
        if(task.TaskNode.ar_date == '0000-00-00')
          body += taskStartTag + comma + 'No Due Date' + taskEndTag;
        else
          body += taskStartTag + comma + 'due:' + task.TaskNode.ar_date + taskEndTag;
        comma = ', ';
      }
      if(secondLine.showPage)
      {
        if(task.Page.name == null)
          pageCategory = 'All';
        else
          pageCategory = task.Page.name;
        body += taskStartTag + comma + 'page:' + pageCategory + taskEndTag;
        comma = ', ';
      }
      if(secondLine.showStatus) {
       // body += '<span id="secondLineStatus' + task.TaskNode.id + '" style="color:grey; text-decoration:underline">' + task.Status.status + taskEndTag;
        body += comma+"<span id='taskStatus" + task.TaskNode.id + "'  class='taskop'>" + task.Status.status + taskEndTag;
        comma = ', ';
      }
      if(secondLine.showCategory) {
        body += taskStartTag + comma + 'list:' + task.List.name + taskEndTag;
        comma = ', ';
      }
      if(secondLine.showPriority)
        body += taskStartTag + comma + 'priority:' + task.TaskNode.priority_id + taskEndTag;
      cell = new Element("td", {style:'-webkit-user-drag:none;cursor:text;-webkit-user-select:auto;'}).update(body);
      row.appendChild(cell);
      div.appendChild(row);
    }

    taskTable.appendChild(div);
    // 6.5 Add event handlers
    this.attachTaskEventHandlers(task.TaskNode.id, task);
    // 6.5.7 For Quick Add link
    if($('taskQuickAddAction' + task.TaskNode.id))
    {
      Event.stopObserving('taskQuickAddAction' + task.TaskNode.id);
      Event.observe('taskQuickAddAction' + task.TaskNode.id, 'click', taskTab.onAddTaskQuickAction.bindAsEventListener(this, task.TaskNode.id) );
    }
  }

  //***************************************************************************
  // The method attaches various event handlers to elements from within a task
  // division for a given task Id.
  //***************************************************************************
  this.attachTaskEventHandlers = function(taskId, /*taskText, taskStatus,*/ taskRec) //taskRec.TaskNode.node, taskRec.Status.status
  {
    var taskStatus = taskRec.Status.status;
    // 6.5.1 For a ... link to show full text, if applicable 
    if($('viewt' + taskId)) 
    {
      Event.stopObserving('viewt' + taskId);
      Event.observe('viewt' + taskId, 'mouseover',  loadTip.bindAsEventListener(this, taskRec.TaskNode.node));
    }
    // 6.5.2 For reply link
    //Event.stopObserving('reply' + taskId);
    //Event.observe('reply' + taskId, 'click', this.onTaskReplyLink.bindAsEventListener(this, taskId) );
    // 6.5.3 For Status link
    if ($('taskStatus' + taskId)) {
      Event.stopObserving('taskStatus' + taskId);
      Event.observe('taskStatus' + taskId, 'click', this.onTaskStatus.bindAsEventListener(this, taskId) );
      // 6.5.4 For Status Context Menu
      if(taskStatus != 'Open')
      {
        Event.stopObserving('changeTaskStatusToOpenLink' + taskId);
        Event.observe('changeTaskStatusToOpenLink' + taskId, 'click', this.onTaskStatusChange.bindAsEventListener(this, 'Open' + taskId) );
      }
      if(taskStatus != 'Completed')
      {
        Event.stopObserving('changeTaskStatusToCompletedLink' + taskId);
        Event.observe('changeTaskStatusToCompletedLink' + taskId, 'click', this.onTaskStatusChange.bindAsEventListener(this, 'Comp' + taskId) );
      }
      if(taskStatus != 'In Progress')
      {
        Event.stopObserving('changeTaskStatusToInProgressLink' + taskId);
        Event.observe('changeTaskStatusToInProgressLink' + taskId, 'click', this.onTaskStatusChange.bindAsEventListener(this, 'InPr' + taskId) );
      }
      if(taskStatus != 'Archived')
      {
        Event.stopObserving('changeTaskStatusToArchivedLink' + taskId);
        Event.observe('changeTaskStatusToArchivedLink' + taskId, 'click', this.onTaskStatusChange.bindAsEventListener(this, 'Arch' + taskId) );
      }
    }
    // 6.5.5 For Action link
    Event.stopObserving('taskAction' + taskId);
    Event.observe('taskAction' + taskId, 'click', this.onTaskAction.bindAsEventListener(this, taskId) );
    Event.observe('taskAction' + taskId, 'mouseover', this.onTaskActionCursor.bindAsEventListener(this, 'taskAction' + taskId, 'over') );
    Event.observe('taskAction' + taskId, 'mouseout', this.onTaskActionCursor.bindAsEventListener(this, 'taskAction' + taskId, 'out') );
    //this is for the colored box next to the task
    if ($('taskStatusB' + taskId)) {
      Event.stopObserving('taskStatusB' + taskId);
      Event.observe('taskStatusB' + taskId, 'click', this.onTaskStatus.bindAsEventListener(this, taskId) );
    }
    // 6.5.6 For Action Context Menu
    Event.stopObserving('taskReplyActionLink' + taskId);
    Event.observe('taskReplyActionLink' + taskId, 'click', this.onTaskActionClick.bindAsEventListener(this, 'Repl' + taskId) );
    Event.stopObserving('taskEditActionLink' + taskId);
    Event.observe('taskEditActionLink' + taskId, 'click', this.onTaskActionClick.bindAsEventListener(this, 'Edit' + taskId, taskRec) );
    //Event.stopObserving('taskViewActionLink' + taskId);
    //Event.observe('taskViewActionLink' + taskId, 'click', this.onTaskActionClick.bindAsEventListener(this, 'View' + taskId) );
    // 6.5.8 Add drag and drop handlers
    // Handlers for a task division as a recipient of drag events
   /* Event.stopObserving('taskDiv' + taskId);
    Event.observe('taskDiv' + taskId, 'dragenter', this.onTaskDragEnter.bindAsEventListener(this, taskId, this.dragdrop) );
    Event.observe('taskDiv' + taskId, 'drop', this.onTaskDragDrop.bindAsEventListener(this, taskId, this.dragdrop) );
    Event.observe('taskDiv' + taskId, 'dragleave', this.onTaskDragLeave.bindAsEventListener(this, taskId, this.dragdrop) );
    Event.observe('taskDiv' + taskId, 'dragover', this.onTaskDragOver.bindAsEventListener(this, taskId, this.dragdrop) );
    // Handlers for a task division as a source of drag events
    Event.observe('taskDiv' + taskId, 'dragstart', this.onTaskDragStart.bindAsEventListener(this, taskId, this.dragdrop) );
    Event.observe('taskDiv' + taskId, 'dragend', this.onTaskDragEnd.bindAsEventListener(this, taskId, this.dragdrop) );
    */
  }

  //***************************************************************************
  // The method adds a new task using values from quick add panel. It is registered
  // as an event listener for the Save button click event and when a user presses Enter.
  // The method is registered as an event listener from onAddTaskQuickAction.
  //***************************************************************************
  this.addTask = function(event, taskId)
  {
    if($('taskQuickAddActionText' + taskId).value == '') return;
    var options = {'token':this.api.token, 'task': $('taskQuickAddActionText' + taskId).value, 'ws_id':'0'};
    air.trace("Token: [" + options.token + "] Task: [" + options.task + "] ws_id: [" + options.ws_id + "]");
    // 1. Determine if tasks are grouped
    var group = this.config.getStringParameter('groupSelection');
    air.trace('Grouped by: ' + group);
    air.trace('Group Value: ' + $('taskQuickAddGroup' + taskId).innerHTML);
    if(group == 'Priority')
    {
      options.pri_id = $('taskQuickAddGroup' + taskId).innerHTML;
    }
    else if(group == 'Person')
    {
      options.res_id = $('taskQuickAddGroup' + taskId).innerHTML;
    }
    else if(group == 'Page')
    {
      options.pg_id = $('taskQuickAddGroup' + taskId).innerHTML;
    }
    else if(group == 'Category')
    {
      options.list_id = $('taskQuickAddGroup' + taskId).innerHTML;
    }
    else if(group == 'Due date')
    {
      options.ar_date = $('taskQuickAddGroup' + taskId).innerHTML;
    }
    // 2. Call API
    var tmp;
    try
    {
      tmp = this.api.callMethod('wizehive.tasks.add', options, 'POST');
      //air.trace(tmp);
      if(tmp.match('rsp stat="ok"')) 
      {
        showStatus('Your task has been added.');
        // 3. Insert a new task
        // TBD
      } 
      else 
      {
        var msg = '';
        if(tmp.indexOf('err code=') != -1) msg = ' Error Code: ' + tmp.substring(tmp.indexOf('err code=') + 10, tmp.indexOf('err code=') + 11);
        alert("Error adding task." + msg); 
      } 
   
      // 4. Clean the text panel
      $('taskQuickAddActionText' + taskId).value = '';
    }
    catch(e)
    {
      //alert(e);
    }
  }
 
  this.getTaskThread = function(taskId)
  {
    var trOptions = {};
    trOptions.format = 'json';
    trOptions.token = this.api.token;
    trOptions.item_type = 'task';
    trOptions.item_id = taskId;
    //air.trace("Format: [" + trOptions.format + "] Token: [" + trOptions.token + "] item_type: [" + 
    //trOptions.item_type + "] item_id: [" + trOptions.item_id + "]");
    // Variables for task replies
    var trJSONCall, trJSONEval, task, posts;
    trJSONCall = this.api.callMethod('wizehive.notes.getThread', trOptions);
    //air.trace(trJSONCall);
    trJSONEval = trJSONCall.evalJSON(true);
    task = trJSONEval.thread.tn.TaskNode;
    posts = trJSONEval.thread.tn.Post;
    posts.each(function (post) {
          alert(post.body);
        });
  }

  //***************************************************************************
  // The following methods are primarily used as event handlers for various 
  // controls/elements in the Tasks tab
  //***************************************************************************

  //***************************************************************************
  // The function is an onclick handler for reply link that is shown below every
  // task and it opens a new window where a user can enter a reply and save it
  // by clicking Save link which is handled by saveModalAction function 
  //***************************************************************************
  this.onTaskReplyLink = function(event, taskId)
  {
    modalWinObject.type = 'task';
    modalWinObject.Id = taskId;
    modalWinObject.operation = 'reply';
    modalWinObject.content = '';
    openModalWindow();
  }

  //***************************************************************************
  // Click event handler for the link Status. The function assumes 
  // that the file menu.js is included as well
  //***************************************************************************
  this.onTaskStatus = function(event, tid)
  {
    return taskTab.processContextMenu(event, tid, 'taskStatusContextMenu');
  }

  //***************************************************************************
  // Click event handler for the linked menu items in the Status context menu.
  //***************************************************************************
  this.onTaskStatusChange = function (event, tid)
  {
    // 1. Determine for which task and to what status it status has to be changed
    var status = tid.substring(0, 4);
    if(status == 'Comp') status = 'Completed';
    else if(status == 'InPr') status = 'InProgress';
    else if(status == 'Arch') status = 'Archived';
    var taskId = tid.substring(4, tid.length);
    // 2. Update task status
    var options = {'token':this.api.token, 'id':taskId, 'status':status};
    var response = this.api.callMethod('wizehive.tasks.edit', options, 'POST');
  
    //air.trace(response);
    // 3. Display a message

    if(response.match('rsp stat="ok"')) 
    {
      showStatus("The task status has been successfully changed to " + status + ".");
    } 
    else 
    {
      alert("Error changing task status to " + status + "."); 
    }
    // 4. Update second line if applicable
    getActivity();
    /*
    if($('secondLineStatus' + taskId)) 
    {
      status = (status == 'InProgress') ? 'In Progress' : status;
      $('secondLineStatus' + taskId).innerHTML = status;
    }
    */
    return false;
  }


  //***************************************************************************
  // Click event handler for the link Action. The function assumes 
  // that the file menu.js is included as well
  //***************************************************************************
  this.onTaskAction = function (event, tid)
  {
    return taskTab.processContextMenu(event, tid, 'taskActionContextMenu');
  }

  this.processContextMenu = function (event, tid, contextMenu)
  {
    // 1. Hide any menu defined as div tag with taskscontextmenu class, i.e. any 
    // other context menu for the Status link that may have been opened before.
    $$('div.taskscontextmenu').invoke('hide');
 
    // 2. Get position of a mouse cursor
    var dim = getEventPosition(event);
    var id = contextMenu + tid;
    // 3. Create context menu and display
    m = new Menu(id, dim);
    m.display();

    return m;
  }

  //***************************************************************************
  // Click event handler for the linked menu items in the Action context menu.
  //***************************************************************************
  this.onTaskActionClick = function(event, tid, taskRec)
  {
    // 1. Determine for which task and to what action has to be carried out
    var taskId = tid.substring(4, tid.length);
    var action = tid.substring(0, 4);
    //air.trace("TID: [" + tid + "] Task ID: [" + taskId + "] Action: [" + action + "]");
    if(action == 'Repl') 
    {
      taskTab.onTaskReplyLink(null, taskId);
      return false;
    }
    else if(action == 'Edit') 
    {                                    	
      modalWinObject.type = 'task';
      modalWinObject.Id = taskId;
      modalWinObject.content = $('taskContent' + taskId).innerHTML;
      modalWinObject.operation = 'edit';
      if (!cats) {
        var tmpJSON = api.callMethod('wizehive.pages.getList',{'format':'json','token':api.token});
        var tmpCats = tmpJSON.evalJSON(true);
        cats = tmpCats.pages;
      }
      if (!lists) {
        var tmpJSON = this.api.callMethod('wizehive.tasks.lists.getList',{'format':'json','token':api.token});
        //air.trace(tmpJSON);
        var tmpLists = tmpJSON.evalJSON(true);
        lists = tmpLists.lists;
      }
      modalWinObject.cats = cats;
      modalWinObject.lists = lists;
      modalWinObject.task = taskRec;
      
      modalWinObject.api = this.api;
      
      openModalWindow();
      return false;
    }
    else if(action == 'View') 
    {
      //TBD
      this.getTaskThread(taskId);
    }
    return false;
  }


  //***************************************************************************
  // The function is called when a user hovers a mouse cursor over actions link
  //***************************************************************************
  this.onTaskActionCursor = function(event, tid, action)
  {
    var opacity = 0.45;
    if(action == 'over') opacity = 1;
    $(tid).style.opacity = opacity;
  }

  
  //***************************************************************************
  // The method displays a quick add panel for a task with passed in task id and registers
  // event handlers for the following controls and events:
  // 1. keypress event (to save a task when a user presses the Enter key) for the quick add text
  // area (id - taskQuickAddActionPanel)
  // 2. click event (to save a task when a user clicks Save button) for the quick add Save
  // button (id - taskQuickAddActionSaveBtn)
  // 3. click event (to close the quick add panel) for the quick add Close link 
  // (id - taskQuickAddActionCloseLnk)
  //***************************************************************************
  this.onAddTaskQuickAction = function(event, taskId)
  {
    if($('taskQuickAddActionPanel' + taskId).style.display != 'none') return;
    // Hide other panels
    $$('div.taskquickaddpanel').invoke('hide');
    $('taskQuickAddActionPanel' + taskId).show();
    $('taskQuickAddActionText' + taskId).focus();
    // Attach listeners
    Event.stopObserving('taskQuickAddActionSaveBtn' + taskId);
    Event.observe('taskQuickAddActionSaveBtn' + taskId, 'click', taskTab.addTask.bindAsEventListener(this, taskId) );
    Event.stopObserving('taskQuickAddActionCloseLnk' + taskId);
    Event.observe('taskQuickAddActionCloseLnk' + taskId, 'click', taskTab.onAddTaskQuickActionClose.bindAsEventListener(this, taskId) );
    Event.observe('taskQuickAddActionPanel' + taskId, 'keypress', function(event) {
        if (event.keyCode == Event.KEY_RETURN && !event.altKey && !event.shiftKey) {
          taskTab.addTask(event, taskId);
          Event.stop(event);
        }
      });
  }

  //***************************************************************************
  // A click event handler for the Close link in the quick add panel. The method
  // removes all listeners for all controls in the quick add panel and hides the panel.
  // It is registered as a handler in onAddTaskQuickAction.
  //***************************************************************************
  this.onAddTaskQuickActionClose = function(event, taskId)
  {
    // Remove listeners
    Event.stopObserving('taskQuickAddActionSaveBtn' + taskId);
    Event.stopObserving('taskQuickAddActionCloseLnk' + taskId);
    Event.stopObserving('taskQuickAddActionPanel' + taskId);
    // Hide quick add panel
    $('taskQuickAddActionPanel' + taskId).hide();
  }

  //***************************************************************************
  // The recipient of a this drag event receives it when a user drags the data
  // into the recipient area.
  //***************************************************************************
  this.onTaskDragEnter = function(event, taskId, dragdrop)
  {
    //air.trace('Recipient: Drag Enter');
    // Disable default drag handling
    event.preventDefault();
    if(!this.isDragDropAllowed())
    {
      return;
    }
    event.dataTransfer.dropEffect = "move";
    // Re-render/Flip recipient and source task divisions
    //air.trace('Target ID: ' + taskId + ' Source ID: ' + dragdrop.sourceId);
    if((taskId != dragdrop.sourceId) && !$('taskDiv' + taskId).transferred)
    {
      $('taskDiv' + taskId).parentNode.insertBefore($('taskDiv' + dragdrop.sourceId), $('taskDiv' + taskId).nextSibling);
      // Make the recipient a target
      dragdrop.targetId = taskId;
      dragdrop.transferred = true;
      $('taskDiv' + taskId).transferred = true;
    }
  }

  this.onTaskDragLeave = function(event, taskId, dragdrop)
  {
    //air.trace('Recipient: Drag Leave');
  }

  this.onTaskDragOver = function(event, taskId, dragdrop)
  {
    // Disable default drag handling
    event.preventDefault();
  }

  //***************************************************************************
  // The recipient of a this drag event receives it when a user drops the data
  // into the recipient area.
  //***************************************************************************
  this.onTaskDragDrop = function(event, taskId, dragdrop)
  {
    air.trace('Recipient: Drag Drop: Transferred: ' + dragdrop.transferred);
    if(dragdrop.transferred)
    {
      alert($('taskRow' + dragdrop.sourceId).parentNode.innerHTML);
      /*TEST
      //air.trace('Target: [' + dragdrop.targetId + ']: ' + $('taskContent' + dragdrop.targetId).innerHTML);
      //air.trace('Source: [' + dragdrop.sourceId + ']: ' + $('taskContent' + dragdrop.sourceId).innerHTML);
      // Make necessary updates to account for a new location of a dragged task
      // Check if tasks were placed in different groups
      if($('taskGroupValue' + dragdrop.targetId).innerHTML != $('taskGroupValue' + dragdrop.sourceId).innerHTML)
      {
        // Update groupings
        // Pull current grouping
        var selectedGroup = this.config.getStringParameter('groupSelection');
        // Update tasks
        var srcOptions = {'token':this.api.token, 'id':dragdrop.sourceId};
        var tgtOptions = {'token':this.api.token, 'id':dragdrop.targetId};
        if(selectedGroup == 'Priority')
        {
          srcOptions.pri_id = $('taskGroupValue' + dragdrop.targetId).innerHTML;
          tgtOptions.pri_id = $('taskGroupValue' + dragdrop.sourceId).innerHTML;
          $('taskGroupValue' + dragdrop.sourceId).innerHTML = srcOptions.pri_id;
          $('taskGroupValue' + dragdrop.targetId).innerHTML = tgtOptions.pri_id;
        }
        else if(selectedGroup == 'Person')
        {
          srcOptions.res_id = $('taskGroupValue' + dragdrop.targetId).innerHTML;
          tgtOptions.res_id = $('taskGroupValue' + dragdrop.sourceId).innerHTML;
          $('taskGroupValue' + dragdrop.sourceId).innerHTML = srcOptions.res_id;
          $('taskGroupValue' + dragdrop.targetId).innerHTML = tgtOptions.res_id;
        }
        else if(selectedGroup == 'Status')
        {
          srcOptions.status = $('taskGroupValue' + dragdrop.targetId).innerHTML;
          tgtOptions.status = $('taskGroupValue' + dragdrop.sourceId).innerHTML;
          $('taskGroupValue' + dragdrop.sourceId).innerHTML = srcOptions.status;
          $('taskGroupValue' + dragdrop.targetId).innerHTML = tgtOptions.status;
        }
        else if(selectedGroup == 'Page')
        {
          srcOptions.pg_id = $('taskGroupValue' + dragdrop.targetId).innerHTML;
          tgtOptions.pg_id = $('taskGroupValue' + dragdrop.sourceId).innerHTML;
          $('taskGroupValue' + dragdrop.sourceId).innerHTML = srcOptions.pg_id;
          $('taskGroupValue' + dragdrop.targetId).innerHTML = tgtOptions.pg_id;
        }
        else if(selectedGroup == 'List')
        {
          srcOptions.list_id = $('taskGroupValue' + dragdrop.targetId).innerHTML;
          tgtOptions.list_id = $('taskGroupValue' + dragdrop.sourceId).innerHTML;
          $('taskGroupValue' + dragdrop.sourceId).innerHTML = srcOptions.list_id;
          $('taskGroupValue' + dragdrop.targetId).innerHTML = tgtOptions.list_id;
        }
        else if(selectedGroup == 'Due date')
        {
          srcOptions.date = $('taskGroupValue' + dragdrop.targetId).innerHTML;
          tgtOptions.date = $('taskGroupValue' + dragdrop.sourceId).innerHTML;
          $('taskGroupValue' + dragdrop.sourceId).innerHTML = srcOptions.date;
          $('taskGroupValue' + dragdrop.targetId).innerHTML = tgtOptions.date;
        }

        var srcResponse, tgtResponse;
        srcResponse = ''; tgtResponse = '';
        try
        {
          srcResponse = this.api.callMethod('wizehive.tasks.edit', srcOptions, 'POST');
          tgtResponse = this.api.callMethod('wizehive.tasks.edit', tgtOptions, 'POST');
          // Display a message
          if(srcResponse.match('rsp stat="ok"') && tgtResponse.match('rsp stat="ok"')) 
          {
            //showStatus("The tasks have been successfully updated.");
          } 
          else 
          {
            showStatus("Error updating tasks.");
          }
        }
        catch(e)
        {
          showStatus("Error updating tasks.");
        }
      }
      */
    }
    dragdrop.targetId = '';
    dragdrop.sourceId = '';
    dragdrop.transferred = false;
  }
  
  //***************************************************************************
  // The source of a this drag event receives it when a user starts dragging the data
  // out of the source area.
  //***************************************************************************
  this.onTaskDragStart = function(event, taskId, dragdrop)
  {
    //air.trace('Source: Drag Start');
    if(!this.isDragDropAllowed())
    {
      return;
    }
    event.dataTransfer.effectAllowed = "move";
    // Set source id in dragdrop object so that the recipient knows what task source
    // needs to be updated once the user enters
    dragdrop.sourceId = taskId;
    dragdrop.targetId = '';
    // Prepare the data for the recipient
    dragdrop.transferred = false;
    //event.dataTransfer.setData('text/html', $('taskDiv' + taskId).innerHTML);
  }

  this.isDragDropAllowed = function()
  {
    var selectedGroup = this.config.getStringParameter('groupSelection');
    if(selectedGroup == 'Created by')
    {
      return false;
    }
    else
      return true;
  }

  //***************************************************************************
  // The source of a this drag event receives it when a user drops the data
  // into the recipient area.
  //***************************************************************************
  this.onTaskDragEnd = function(event, taskId, dragdrop)
  {
    //air.trace('Source: Drag End');
  }
}

//***************************************************************************
// Returns a two-element array of event coordinates in the format x:posx, y:posy
//***************************************************************************
function getEventPosition(event)
{
  var posx = 0;
  var posy = 0;
  if(!event) var event = window.event;
  if(event.pageX || event.pageY) 	
  {
    posx = event.pageX;
    posy = event.pageY;
  }
  else if(event.clientX || event.clientY) 	
  {
    posx = event.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
    posy = event.clientY + document.body.scrollTop + document.documentElement.scrollTop;
  }
  return {'x':posx,'y':posy};
}
